
/*  This file is part of the program psim.

    Copyright (C) 1994-1995, Andrew Cagney <cagney@highland.com.au>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
    --

    This file was generated by the program igen */

#ifndef _SEMANTICS_C_
#define _SEMANTICS_C_


#include "cpu.h"
#include "idecode.h"
#include "semantics.h"
#ifdef HAVE_COMMON_FPU
#include "sim-inline.h"
#include "sim-fpu.h"
#endif
#include "support.h"

int option_mpc860c0 = 0;

PSIM_EXTERN_SEMANTICS(void)
semantic_init(device* root)
{
  option_mpc860c0 = 0;
  if (tree_find_property(root, "/options/mpc860c0"))
    option_mpc860c0 = tree_find_integer_property(root, "/options/mpc860c0");
    option_mpc860c0 *= 4;   /* convert word count to byte count */
}


PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_instruction_call(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_instruction_call
#undef MY_PREFIX
#define MY_PREFIX instruction_call

  /* extraction: 0.0,6./,11./,16./,21./,31.1 #define get-values-from-icache */
#line 62 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1494 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics instruction_call\n"));
#line 68 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_instruction_call, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1494 "./ppc-instructions"
  {
    if (!os_emul_instruction_call(processor, cia, real_addr(cia, 1)))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
  }
#line 83 "semantics.c"
  return nia;
  /* extraction: 0.0,6./,11./,16./,21./,31.1 #undef get-values-from-icache */
#line 86 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Trap_Word_Immediate(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Trap_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Trap_Word_Immediate

  /* extraction: 0.3,6.TO,11.RA,16.SI #define get-values-from-icache */
#define TO cache_entry->crack.D.TO /* default in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 109 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2898 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Trap Word Immediate\n"));
#line 115 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Trap_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2898 "./ppc-instructions"
  {
    signed_word a = EXTENDED(*rA);
    signed_word b = EXTS(SI);
    if ((a < b && TO_0_)
        || (a > b && TO_1_)
        || (a == b && TO_2_)
        || ((unsigned_word)a < (unsigned_word)b && TO_3_)
        || ((unsigned_word)a > (unsigned_word)b && TO_4_)
        )
      program_interrupt(processor, cia,
                        trap_program_interrupt);
  }
#line 137 "semantics.c"
  return nia;
  /* extraction: 0.3,6.TO,11.RA,16.SI #undef get-values-from-icache */
#undef TO
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 146 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Immediate(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Immediate
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Immediate

  /* extraction: 0.7,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 171 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2688 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Immediate\n"));
#line 177 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2688 "./ppc-instructions"
  {
    signed_word prod = *rA * EXTS(SI);
    *rT = prod;
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
  }
#line 192 "semantics.c"
  return nia;
  /* extraction: 0.7,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 203 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Immediate_Carrying(cpu *processor,
                                          idecode_cache *cache_entry,
                                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Immediate_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Immediate_Carrying

  /* extraction: 0.8,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 228 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2575 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Immediate Carrying\n"));
#line 234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Immediate_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2575 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(EXTS(SI));
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, 0/*OE*/, 0/*Rc*/);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
  }
#line 252 "semantics.c"
  return nia;
  /* extraction: 0.8,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 263 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare_Logical_Immediate(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Logical_Immediate
#undef MY_PREFIX
#define MY_PREFIX Compare_Logical_Immediate

  /* extraction: 0.10,6.BF,9./,10.L,11.RA,16.UI #define get-values-from-icache */
#define BF cache_entry->crack.D.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.D.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.D.L /* default in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 288 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2834 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare Logical Immediate\n"));
#line 294 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare_Logical_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2834 "./ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      unsigned_word a;
      unsigned_word b = UI;
      if (L == 0)
        a = MASKED(*rA, 32, 63);
      else
        a = *rA;
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK, BF_BITMASK);
  }
#line 319 "semantics.c"
  return nia;
  /* extraction: 0.10,6.BF,9./,10.L,11.RA,16.UI #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare_Immediate(cpu *processor,
                           idecode_cache *cache_entry,
                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Immediate
#undef MY_PREFIX
#define MY_PREFIX Compare_Immediate

  /* extraction: 0.11,6.BF,9./,10.L,11.RA,16.SI #define get-values-from-icache */
#define BF cache_entry->crack.D.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.D.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.D.L /* default in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 355 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2792 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare Immediate\n"));
#line 361 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2792 "./ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      signed_word a;
      signed_word b = EXTS(SI);
      if (L == 0)
        a = EXTENDED(*rA);
      else
        a = *rA;
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK, BF_BITMASK);
  }
#line 386 "semantics.c"
  return nia;
  /* extraction: 0.11,6.BF,9./,10.L,11.RA,16.SI #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 397 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Carrying(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Carrying

  /* extraction: 0.12,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 422 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2555 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Carrying\n"));
#line 428 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2555 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(EXTS(SI));
    ALU_END(*rT, 1/*CA*/, 0/*OE*/, 0/*Rc*/);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 0/*Rc*/);
  }
#line 444 "semantics.c"
  return nia;
  /* extraction: 0.12,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 455 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Carrying_and_Record(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Carrying_and_Record
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Carrying_and_Record

  /* extraction: 0.13,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 480 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2565 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Carrying and Record\n"));
#line 486 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Carrying_and_Record, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2565 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(EXTS(SI));
    ALU_END(*rT, 1/*CA*/, 0/*OE*/, 1/*Rc*/);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, 1/*Rc*/);
  }
#line 502 "semantics.c"
  return nia;
  /* extraction: 0.13,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 513 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_RA0(cpu *processor,
                           idecode_cache *cache_entry,
                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_RA0

  /* extraction: 0.14,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA 0 /* in icache - constant field */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 1 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 538 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2513 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate\n"));
#line 544 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2513 "./ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI);
    else		*rT = *rA + EXTS(SI);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 560 "semantics.c"
  return nia;
  /* extraction: 0.14,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 571 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_RA(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_RA

  /* extraction: 0.14,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 0 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 596 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2513 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate\n"));
#line 602 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2513 "./ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI);
    else		*rT = *rA + EXTS(SI);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 618 "semantics.c"
  return nia;
  /* extraction: 0.14,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 629 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Shifted_RA0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Shifted_RA0

  /* extraction: 0.15,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA 0 /* in icache - constant field */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 1 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 654 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2523 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Shifted\n"));
#line 660 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2523 "./ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI) << 16;
    else		*rT = *rA + (EXTS(SI) << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 676 "semantics.c"
  return nia;
  /* extraction: 0.15,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 687 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Immediate_Shifted_RA(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX Add_Immediate_Shifted_RA

  /* extraction: 0.15,6.RT,11.RA,16.SI #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 0 /* RA == 0 */ /* semantic compute - constant compare */
#define EXTS_SI cache_entry->crack.D.EXTS_SI /* in icache - extraction */
#line 712 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2523 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Immediate Shifted\n"));
#line 718 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2523 "./ppc-instructions"
  {
    if (RA_is_0)	*rT = EXTS(SI) << 16;
    else		*rT = *rA + (EXTS(SI) << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rT, (long)*rT));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 734 "semantics.c"
  return nia;
  /* extraction: 0.15,6.RT,11.RA,16.SI #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_SI
#line 745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 767 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 773 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 822 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 830 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 852 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 858 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 907 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 915 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 937 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 943 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 992 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1000 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1022 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1028 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1077 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1085 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1107 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1113 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1162 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1170 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1192 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1198 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1247 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1255 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1277 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1283 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1332 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1340 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1362 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1368 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1417 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1425 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1447 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1453 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1502 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1510 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1532 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1538 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1587 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1595 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1617 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1623 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1672 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1680 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1702 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1708 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1757 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1765 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1787 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1793 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1842 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1850 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1872 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1878 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 1927 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 1935 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 1957 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 1963 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2012 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2020 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2042 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2048 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2097 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2105 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2127 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2133 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2182 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2190 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2212 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2218 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2267 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2275 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2297 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2352 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2360 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2382 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2388 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2437 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2445 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2467 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2473 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2522 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2530 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2552 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2558 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2607 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2615 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2637 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2643 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2692 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2700 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2722 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2728 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2777 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2785 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2807 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2813 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2862 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2870 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2892 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2898 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 2947 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 2955 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 2977 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 2983 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3032 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3040 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3062 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3068 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3117 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3125 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3147 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3153 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3202 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3210 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3232 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3238 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3287 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3295 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3317 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3323 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3372 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3380 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK0_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK0_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 3402 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3408 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3457 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3465 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3487 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3493 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3542 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3550 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3572 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3578 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3627 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3635 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3657 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3663 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3712 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3720 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3742 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3748 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3797 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3805 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3827 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3833 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3882 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3890 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3912 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 3918 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 3967 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 3975 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 3997 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4003 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4052 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4060 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4082 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4088 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4137 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4145 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4167 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4173 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4222 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4230 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4252 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4258 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4307 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4315 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4337 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4343 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4392 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4400 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4422 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4428 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4477 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4485 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4507 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4513 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4562 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4570 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4592 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4598 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4647 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4655 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4677 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4683 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4732 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4740 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4762 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4768 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4817 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4825 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4847 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4853 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4902 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4910 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 4932 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 4938 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 4987 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 4995 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5017 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5023 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5072 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5080 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5102 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5108 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5157 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5165 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5187 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5193 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5242 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5250 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5272 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5278 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5327 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5335 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5357 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5363 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5412 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5420 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5442 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5448 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5497 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5505 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5527 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5533 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5582 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5590 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5612 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5618 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5667 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5675 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5697 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5703 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5752 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5760 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5782 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5788 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5837 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5845 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5867 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5873 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 5922 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 5930 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 5952 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 5958 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6007 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6015 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 6037 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6043 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6092 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6100 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA0_LK1_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA0_LK1_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 6122 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6128 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6177 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6185 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6207 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6213 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6262 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6270 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6292 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6298 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6347 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6355 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6377 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6383 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6432 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6440 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6462 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6468 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6517 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6525 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6547 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6553 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6602 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6610 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6632 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6638 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6687 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6695 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6717 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6723 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6772 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6780 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6802 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6808 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6857 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6865 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6887 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6893 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 6942 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 6950 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 6972 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 6978 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7027 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7057 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7063 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7112 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7120 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7142 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7148 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7197 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7205 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7227 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7233 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7282 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7290 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7312 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7318 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7367 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7375 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7397 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7403 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7452 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7460 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7482 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7488 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7537 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7545 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7567 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7573 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7622 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7630 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7652 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7658 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7707 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7715 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7737 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7743 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7792 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7800 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7822 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7828 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7877 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7885 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7907 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7913 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 7962 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 7970 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 7992 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 7998 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8047 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8055 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8077 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8083 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8132 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8162 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8168 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8217 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8225 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8247 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8253 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8302 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8310 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8332 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8338 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8387 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8395 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8417 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8423 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8472 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8480 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8502 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8508 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8557 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8565 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8587 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8593 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8642 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8650 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8672 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8678 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8727 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8735 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8757 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8763 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8812 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8820 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK0_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK0_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 8842 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8848 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8897 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8905 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO0

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 0 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 8927 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 8933 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 8982 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 8990 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO1

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 1 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9012 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9018 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9067 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9075 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO2(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO2

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 2 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9097 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9103 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9152 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9160 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO3(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO3

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 3 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9182 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9188 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9237 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9245 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO4(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO4

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 4 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9267 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9273 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9322 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9330 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO5(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO5

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 5 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9352 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9358 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9407 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9415 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO6(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO6

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 6 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9437 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9443 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9492 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9500 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO7(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO7

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 7 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9522 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9528 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9577 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9585 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO8(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO8

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 8 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9607 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9613 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9662 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9670 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO9(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO9

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 9 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9692 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9698 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9747 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9755 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO10(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO10

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 10 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9777 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9783 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9832 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9840 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO11(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO11

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 11 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9862 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9868 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 9917 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 9925 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO12(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO12

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 12 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 9947 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 9953 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10002 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10010 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO13(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO13

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 13 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10032 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10038 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10087 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10095 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO14(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO14

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 14 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10117 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10123 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10172 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10180 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO15(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO15

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 15 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10202 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10208 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10257 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10265 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO16(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO16

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 16 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10287 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10342 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10350 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO17(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO17

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 17 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10372 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10378 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10427 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10435 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO18(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO18

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 18 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10457 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10463 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10512 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10520 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO19(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO19

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 19 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10542 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10548 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10597 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10605 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO20(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO20

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 20 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10627 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10633 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10682 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10690 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO21(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO21

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 21 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10712 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10718 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10767 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10775 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO22(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO22

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 22 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10797 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10803 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10852 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10860 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO23(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO23

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 23 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10882 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10888 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 10937 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 10945 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO24(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO24

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 24 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 10967 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 10973 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11022 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11030 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO25(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO25

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 25 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11052 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11058 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11107 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11115 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO26(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO26

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 26 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11137 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11143 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11192 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11200 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO27(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO27

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 27 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11222 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11228 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11277 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11285 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO28(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO28

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 28 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11307 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11313 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11362 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11370 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO29(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO29

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 29 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11392 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11398 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11447 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11455 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO30(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO30

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 30 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11477 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11483 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11532 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11540 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_AA1_LK1_BO31(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_AA1_LK1_BO31

  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #define get-values-from-icache */
#define BO 31 /* default in icache - constant field */
#define BIT32_BI cache_entry->crack.B.BIT32_BI /* in icache - extraction */
#define EXTS_BD_0b00 cache_entry->crack.B.EXTS_BD_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11562 "semantics.c"

#define insn cache_entry->crack.B.insn
  unsigned_word nia;
#line 1519 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional\n"));
#line 11568 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1519 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != (BO_3_));
    cond_ok = BO_0_ || ((CR_BI_) == (BO_1_));
    if (ctr_ok && cond_ok) {
      if (AA) NIA = IEA(EXTS(BD_0b00));
      else    NIA = IEA(CIA + EXTS(BD_0b00));
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as "normal".
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), succeed, BO);
    if (! BO_0_) {
      int reverse;
      if (BO_4_) {	/* branch prediction bit set, reverse sense of test */
        reverse = EXTS(BD_0b00) < 0;
      } else {	/* branch prediction bit not set */
        reverse = EXTS(BD_0b00) >= 0;
      }
      if (CURRENT_MODEL_ISSUE > 0)
        model_branch_predict(cpu_model(processor), reverse ? !succeed : succeed);
    }
  }
#line 11617 "semantics.c"
  return nia;
  /* extraction: 0.16,6.BO,11.BI,16.BD,30.AA,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef EXTS_BD_0b00
#undef AA
#undef LK
#line 11625 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_System_Call(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_System_Call
#undef MY_PREFIX
#define MY_PREFIX System_Call

  /* extraction: 0.17,6./,11./,16./,30.1,31./ #define get-values-from-icache */
#line 11642 "semantics.c"

#define insn cache_entry->crack.SC.insn
  unsigned_word nia;
#line 1631 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics System Call\n"));
#line 11648 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_System_Call, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1631 "./ppc-instructions"
  {
    if (CURRENT_MODEL_ISSUE > 0)
      model_serialize(MY_INDEX, cpu_model(processor));
    system_call_interrupt(processor, cia);
  }
#line 11663 "semantics.c"
  return nia;
  /* extraction: 0.17,6./,11./,16./,30.1,31./ #undef get-values-from-icache */
#line 11666 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA0_LK0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA0_LK0

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 11686 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11692 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "./ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11711 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11717 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA0_LK1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA0_LK1

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 0 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11737 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11743 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "./ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11762 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11768 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA1_LK0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA1_LK0

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 0 /* default in icache - constant field */
#line 11788 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11794 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "./ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11813 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11819 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_AA1_LK1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch
#undef MY_PREFIX
#define MY_PREFIX Branch_AA1_LK1

  /* extraction: 0.18,6.LI,30.AA,31.LK #define get-values-from-icache */
#define EXTS_LI_0b00 cache_entry->crack.I.EXTS_LI_0b00 /* in icache - extraction */
#define AA 1 /* default in icache - constant field */
#define LK 1 /* default in icache - constant field */
#line 11839 "semantics.c"

#define insn cache_entry->crack.I.insn
  unsigned_word nia;
#line 1506 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch\n"));
#line 11845 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1506 "./ppc-instructions"
  {
    /* option_mpc860c0:
    No problem here because this branch is predicted taken (unconditional). */
    if (AA) NIA = IEA(EXTS(LI_0b00));
    else    NIA = IEA(CIA + EXTS(LI_0b00));
    if (LK) LR = (spreg)CIA+4;
    if (CURRENT_MODEL_ISSUE > 0)
      model_branches(cpu_model(processor), 1, -1);
  }
#line 11864 "semantics.c"
  return nia;
  /* extraction: 0.18,6.LI,30.AA,31.LK #undef get-values-from-icache */
#undef EXTS_LI_0b00
#undef AA
#undef LK
#line 11870 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_Condition_Register_Field(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_Condition_Register_Field
#undef MY_PREFIX
#define MY_PREFIX Move_Condition_Register_Field

  /* extraction: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ #define get-values-from-icache */
#define BF cache_entry->crack.XL.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.XL.BF_BITMASK /* in icache - extraction */
#define BFA cache_entry->crack.XL.BFA /* default in icache - extraction */
#line 11890 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1710 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move Condition Register Field\n"));
#line 11896 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_Condition_Register_Field, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1710 "./ppc-instructions"
  {
    MBLIT32(CR, 4*BF, 4*BF+3, EXTRACTED32(CR, 4*BFA, 4*BFA+3));
    PPC_INSN_CR(BF_BITMASK, 1 << BFA);
  }
#line 11910 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BF,9./,11.BFA,14./,16./,21.0,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef BFA
#line 11916 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Link_Register_LK0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Link_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Link_Register_LK0

  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 0 /* default in icache - constant field */
#line 11936 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1562 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Link Register\n"));
#line 11942 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Link_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1562 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != BO_3_);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (ctr_ok && cond_ok) {
      NIA = IEA(LR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 11983 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 11989 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Link_Register_LK1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Link_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Link_Register_LK1

  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 1 /* default in icache - constant field */
#line 12009 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1562 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Link Register\n"));
#line 12015 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Link_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1562 "./ppc-instructions"
  {
    int M, ctr_ok, cond_ok, succeed;
    if (is_64bit_implementation && is_64bit_mode) M = 0;
    else                                          M = 32;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    if (!BO_2_) CTR = CTR - 1;
    ctr_ok = BO_2_ || ((MASKED(CTR, M, 63) != 0) != BO_3_);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (ctr_ok && cond_ok) {
      NIA = IEA(LR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 12056 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.16,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 12062 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_NOR(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_NOR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_NOR

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.33,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12085 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1675 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register NOR\n"));
#line 12091 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_NOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1675 "./ppc-instructions"
  {
    BLIT32(CR, BT, !(CR_BA_ || CR_BB_));
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12105 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.33,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12114 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Return_From_Interrupt(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Return_From_Interrupt
#undef MY_PREFIX
#define MY_PREFIX Return_From_Interrupt

  /* extraction: 0.19,6./,11./,16./,21.50,31./ #define get-values-from-icache */
#line 12131 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 4847 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Return From Interrupt\n"));
#line 12137 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Return_From_Interrupt, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4847 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor)) {
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    }
    else {
      MSR = (MASKED(SRR1, 0, 32)
             | MASKED(SRR1, 37, 41)
             | MASKED(SRR1, 48, 63));
      NIA = MASKED(SRR0, 0, 61);
      cpu_synchronize_context(processor, cia);
      check_masked_interrupts(processor);
    }
  }
#line 12161 "semantics.c"
  return nia;
  /* extraction: 0.19,6./,11./,16./,21.50,31./ #undef get-values-from-icache */
#line 12164 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_AND_with_Complement(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_AND_with_Complement

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.129,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12187 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1691 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register AND with Complement\n"));
#line 12193 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_AND_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1691 "./ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ && !CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12207 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.129,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12216 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Instruction_Synchronize(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Instruction_Synchronize
#undef MY_PREFIX
#define MY_PREFIX Instruction_Synchronize

  /* extraction: 0.19,6./,11./,16./,21.150,31./ #define get-values-from-icache */
#line 12233 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 4760 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Instruction Synchronize\n"));
#line 12239 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Instruction_Synchronize, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4760 "./ppc-instructions"
  {
    cpu_synchronize_context(processor, cia);
    PPC_INSN_INT(0, 0, 0);
  }
#line 12253 "semantics.c"
  return nia;
  /* extraction: 0.19,6./,11./,16./,21.150,31./ #undef get-values-from-icache */
#line 12256 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_XOR(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_XOR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_XOR

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.193,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12279 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1659 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register XOR\n"));
#line 12285 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_XOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1659 "./ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ != CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12299 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.193,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12308 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_NAND(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_NAND
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_NAND

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.225,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12331 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1667 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register NAND\n"));
#line 12337 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_NAND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1667 "./ppc-instructions"
  {
    BLIT32(CR, BT, !(CR_BA_ && CR_BB_));
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12351 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.225,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12360 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_AND(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_AND
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_AND

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.257,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12383 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1643 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register AND\n"));
#line 12389 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_AND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1643 "./ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ && CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12403 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.257,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12412 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_Equivalent(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_Equivalent

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.289,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12435 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1683 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register Equivalent\n"));
#line 12441 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_Equivalent, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1683 "./ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ == CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12455 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.289,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12464 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_OR_with_Complement(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_OR_with_Complement

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.417,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12487 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1699 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register OR with Complement\n"));
#line 12493 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_OR_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1699 "./ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ || !CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12507 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.417,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12516 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Condition_Register_OR(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Condition_Register_OR
#undef MY_PREFIX
#define MY_PREFIX Condition_Register_OR

  /* extraction: 0.19,6.BT,11.BA,16.BB,21.449,31./ #define get-values-from-icache */
#define BT cache_entry->crack.XL.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.XL.BT_BITMASK /* in icache - extraction */
#define BIT32_BA cache_entry->crack.XL.BIT32_BA /* in icache - extraction */
#define BA_BITMASK cache_entry->crack.XL.BA_BITMASK /* in icache - extraction */
#define BIT32_BB cache_entry->crack.XL.BIT32_BB /* in icache - extraction */
#define BB_BITMASK cache_entry->crack.XL.BB_BITMASK /* in icache - extraction */
#line 12539 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1651 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Condition Register OR\n"));
#line 12545 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Condition_Register_OR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1651 "./ppc-instructions"
  {
    BLIT32(CR, BT, CR_BA_ || CR_BB_);
    PPC_INSN_CR(BT_BITMASK, BA_BITMASK | BB_BITMASK);
  }
#line 12559 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BT,11.BA,16.BB,21.449,31./ #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef BIT32_BA
#undef BA_BITMASK
#undef BIT32_BB
#undef BB_BITMASK
#line 12568 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Count_Register_LK0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Count_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Count_Register_LK0

  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 0 /* default in icache - constant field */
#line 12588 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1597 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Count Register\n"));
#line 12594 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Count_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1597 "./ppc-instructions"
  {
    int cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (cond_ok) {
      NIA = IEA(CTR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 12631 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 12637 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Branch_Conditional_to_Count_Register_LK1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Branch_Conditional_to_Count_Register
#undef MY_PREFIX
#define MY_PREFIX Branch_Conditional_to_Count_Register_LK1

  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #define get-values-from-icache */
#define BO cache_entry->crack.XL.BO /* default in icache - extraction */
#define BIT32_BI cache_entry->crack.XL.BIT32_BI /* in icache - extraction */
#define LK 1 /* default in icache - constant field */
#line 12657 "semantics.c"

#define insn cache_entry->crack.XL.insn
  unsigned_word nia;
#line 1597 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Branch Conditional to Count Register\n"));
#line 12663 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Branch_Conditional_to_Count_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1597 "./ppc-instructions"
  {
    int cond_ok, succeed;
    if (CURRENT_MODEL_ISSUE > 0 && ! BO_0_)
      model_wait_for_cr(cpu_model(processor), BIT32_BI);
    cond_ok = BO_0_ || (CR_BI_ == BO_1_);
    if (cond_ok) {
      NIA = IEA(CTR_0b00);
      succeed = 1;
    }
    else
      succeed = 0;
    if (LK) LR = (spreg)IEA(CIA + 4);
    if (option_mpc860c0 && (!BO_0_ || !BO_2_) && !BO_4_) {
      /* This branch is predicted as not-taken.
      If this is a forward branch and it is near the end of a page,
      we've detected a problematic branch. */
      if (succeed && NIA > CIA) {
        if (PAGE_SIZE - (CIA & (PAGE_SIZE-1)) <= option_mpc860c0)
          program_interrupt(processor, cia, mpc860c0_instruction_program_interrupt);
      }
    }
    if (CURRENT_MODEL_ISSUE > 0) {
      model_branches(cpu_model(processor), succeed, BO);
      if (! BO_0_)
        model_branch_predict(cpu_model(processor), BO_4_ ? !succeed : succeed);
    }
  }
#line 12700 "semantics.c"
  return nia;
  /* extraction: 0.19,6.BO,11.BI,16./,21.528,31.LK #undef get-values-from-icache */
#undef BO
#undef BIT32_BI
#undef LK
#line 12706 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0(cpu *processor,
                                                         idecode_cache *cache_entry,
                                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_Mask_Insert
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_Mask_Insert_Rc0

  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 12734 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3232 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then Mask Insert\n"));
#line 12740 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_Mask_Insert, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3232 "./ppc-instructions"
  {
    long n = SH;
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = (r & m) | (*rA & ~m);
    *rA = result;
    ITRACE(trace_alu, (": n=%ld *rS=0x%lx r=0x%lx m=0x%lx result=0x%lx\n",
                       n, (unsigned long)*rS, (unsigned long)r, (unsigned long)m,
    		   (unsigned long)result));
    CR0_COMPARE(result, 0, Rc);
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12762 "semantics.c"
  return nia;
  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12776 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1(cpu *processor,
                                                         idecode_cache *cache_entry,
                                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_Mask_Insert
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_Mask_Insert_Rc1

  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 12804 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3232 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then Mask Insert\n"));
#line 12810 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_Mask_Insert, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3232 "./ppc-instructions"
  {
    long n = SH;
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = (r & m) | (*rA & ~m);
    *rA = result;
    ITRACE(trace_alu, (": n=%ld *rS=0x%lx r=0x%lx m=0x%lx result=0x%lx\n",
                       n, (unsigned long)*rS, (unsigned long)r, (unsigned long)m,
    		   (unsigned long)result));
    CR0_COMPARE(result, 0, Rc);
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12832 "semantics.c"
  return nia;
  /* extraction: 0.20,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12846 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0(cpu *processor,
                                                           idecode_cache *cache_entry,
                                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc0

  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 12874 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3179 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then AND with Mask\n"));
#line 12880 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3179 "./ppc-instructions"
  {
    long n = SH;
    unsigned32 s = *rS;
    unsigned32 r = ROTL32(s, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
    ITRACE(trace_alu,
           ("n=%ld, s=0x%lx, r=0x%lx, m=0x%lx, result=0x%lx, cr=0x%lx\n",
            n, (unsigned long)s, (unsigned long)r, (unsigned long)m,
    	(unsigned long)result, (unsigned long)CR));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12904 "semantics.c"
  return nia;
  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12918 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1(cpu *processor,
                                                           idecode_cache *cache_entry,
                                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_Immediate_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_Immediate_then_AND_with_Mask_Rc1

  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.M.SH /* default in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 12946 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3179 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word Immediate then AND with Mask\n"));
#line 12952 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_Immediate_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3179 "./ppc-instructions"
  {
    long n = SH;
    unsigned32 s = *rS;
    unsigned32 r = ROTL32(s, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
    ITRACE(trace_alu,
           ("n=%ld, s=0x%lx, r=0x%lx, m=0x%lx, result=0x%lx, cr=0x%lx\n",
            n, (unsigned long)s, (unsigned long)r, (unsigned long)m,
    	(unsigned long)result, (unsigned long)CR));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 12976 "semantics.c"
  return nia;
  /* extraction: 0.21,6.RS,11.RA,16.SH,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef MB
#undef ME
#undef Rc
#line 12990 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_then_AND_with_Mask_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_then_AND_with_Mask_Rc0

  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.M.RB /* in icache - extraction */
#define rB cache_entry->crack.M.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.M.RB_BITMASK /* in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 13020 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3211 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word then AND with Mask\n"));
#line 13026 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3211 "./ppc-instructions"
  {
    long n = MASKED(*rB, 59, 63);
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
  }
#line 13044 "semantics.c"
  return nia;
  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef MB
#undef ME
#undef Rc
#line 13060 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Rotate_Left_Word_then_AND_with_Mask_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Rotate_Left_Word_then_AND_with_Mask
#undef MY_PREFIX
#define MY_PREFIX Rotate_Left_Word_then_AND_with_Mask_Rc1

  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.M.RS /* in icache - extraction */
#define rS cache_entry->crack.M.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.M.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.M.RA /* in icache - extraction */
#define rA cache_entry->crack.M.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.M.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.M.RB /* in icache - extraction */
#define rB cache_entry->crack.M.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.M.RB_BITMASK /* in icache - extraction */
#define MB cache_entry->crack.M.MB /* default in icache - extraction */
#define ME cache_entry->crack.M.ME /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 13090 "semantics.c"

#define insn cache_entry->crack.M.insn
  unsigned_word nia;
#line 3211 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Rotate Left Word then AND with Mask\n"));
#line 13096 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Rotate_Left_Word_then_AND_with_Mask, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3211 "./ppc-instructions"
  {
    long n = MASKED(*rB, 59, 63);
    unsigned32 r = ROTL32(*rS, n);
    unsigned32 m = MASK(MB+32, ME+32);
    signed_word result = r & m;
    *rA = result;
    CR0_COMPARE(result, 0, Rc);
  }
#line 13114 "semantics.c"
  return nia;
  /* extraction: 0.23,6.RS,11.RA,16.RB,21.MB,26.ME,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef MB
#undef ME
#undef Rc
#line 13130 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Immediate(cpu *processor,
                      idecode_cache *cache_entry,
                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_Immediate
#undef MY_PREFIX
#define MY_PREFIX OR_Immediate

  /* extraction: 0.24,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13155 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2975 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR Immediate\n"));
#line 13161 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2975 "./ppc-instructions"
  {
    *rA = *rS | UI;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13176 "semantics.c"
  return nia;
  /* extraction: 0.24,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13187 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Immediate_Shifted(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX OR_Immediate_Shifted

  /* extraction: 0.25,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13212 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2984 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR Immediate Shifted\n"));
#line 13218 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2984 "./ppc-instructions"
  {
    *rA = *rS | (UI << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13233 "semantics.c"
  return nia;
  /* extraction: 0.25,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13244 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Immediate(cpu *processor,
                       idecode_cache *cache_entry,
                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR_Immediate
#undef MY_PREFIX
#define MY_PREFIX XOR_Immediate

  /* extraction: 0.26,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13269 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2993 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR Immediate\n"));
#line 13275 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2993 "./ppc-instructions"
  {
    *rA = *rS ^ UI;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13290 "semantics.c"
  return nia;
  /* extraction: 0.26,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13301 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Immediate_Shifted(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX XOR_Immediate_Shifted

  /* extraction: 0.27,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13326 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3002 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR Immediate Shifted\n"));
#line 13332 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3002 "./ppc-instructions"
  {
    *rA = *rS ^ (UI << 16);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 0/*Rc*/);
  }
#line 13347 "semantics.c"
  return nia;
  /* extraction: 0.27,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13358 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Immediate(cpu *processor,
                       idecode_cache *cache_entry,
                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_Immediate
#undef MY_PREFIX
#define MY_PREFIX AND_Immediate

  /* extraction: 0.28,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13383 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2955 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND Immediate\n"));
#line 13389 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2955 "./ppc-instructions"
  {
    *rA = *rS & UI;
    CR0_COMPARE(*rA, 0, 1/*Rc*/);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 1/*Rc*/);
  }
#line 13405 "semantics.c"
  return nia;
  /* extraction: 0.28,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13416 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Immediate_Shifted(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_Immediate_Shifted
#undef MY_PREFIX
#define MY_PREFIX AND_Immediate_Shifted

  /* extraction: 0.29,6.RS,11.RA,16.UI #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define UI cache_entry->crack.D.UI /* default in icache - extraction */
#line 13441 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2965 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND Immediate Shifted\n"));
#line 13447 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_Immediate_Shifted, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2965 "./ppc-instructions"
  {
    *rA = *rS & (UI << 16);
    CR0_COMPARE(*rA, 0, 1/*Rc*/);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, 1/*Rc*/);
  }
#line 13463 "semantics.c"
  return nia;
  /* extraction: 0.29,6.RS,11.RA,16.UI #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef UI
#line 13474 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare
#undef MY_PREFIX
#define MY_PREFIX Compare

  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.X.L /* default in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 13501 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2811 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare\n"));
#line 13507 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2811 "./ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      signed_word a;
      signed_word b;
      if (L == 0) {
        a = EXTENDED(*rA);
        b = EXTENDED(*rB);
      }
      else {
        a = *rA;
        b = *rB;
      }
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK | RB_BITMASK, BF_BITMASK);
  }
#line 13536 "semantics.c"
  return nia;
  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.0,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 13549 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Trap_Word(cpu *processor,
                   idecode_cache *cache_entry,
                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Trap_Word
#undef MY_PREFIX
#define MY_PREFIX Trap_Word

  /* extraction: 0.31,6.TO,11.RA,16.RB,21.4,31./ #define get-values-from-icache */
#define TO cache_entry->crack.X.TO /* default in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 13574 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2931 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Trap Word\n"));
#line 13580 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Trap_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2931 "./ppc-instructions"
  {
    signed_word a = EXTENDED(*rA);
    signed_word b = EXTENDED(*rB);
    if (TO == 12 && rA == rB) {
      ITRACE(trace_breakpoint, ("breakpoint\n"));
      cpu_halt(processor, cia, was_trap, 0);
    }
    else if ((a < b && TO_0_)
        || (a > b && TO_1_)
        || (a == b && TO_2_)
        || ((unsigned_word)a < (unsigned_word)b && TO_3_)
        || ((unsigned_word)a > (unsigned_word)b && TO_4_)
        )
      program_interrupt(processor, cia,
                        trap_program_interrupt);
  }
#line 13606 "semantics.c"
  return nia;
  /* extraction: 0.31,6.TO,11.RA,16.RB,21.4,31./ #undef get-values-from-icache */
#undef TO
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 13617 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE0_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 13646 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 13652 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "./ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13671 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13686 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE0_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 13715 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 13721 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "./ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13740 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13755 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE0_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 13784 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 13790 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13806 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13821 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE0_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 13850 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 13856 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13872 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 13887 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Unsigned_Rc0(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Unsigned_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 13915 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2731 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word Unsigned\n"));
#line 13921 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2731 "./ppc-instructions"
  {
    unsigned64 a = (unsigned32)(*rA);
    unsigned64 b = (unsigned32)(*rB);
    unsigned64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 13940 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 13954 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Unsigned_Rc1(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Unsigned_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 13982 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2731 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word Unsigned\n"));
#line 13988 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2731 "./ppc-instructions"
  {
    unsigned64 a = (unsigned32)(*rA);
    unsigned64 b = (unsigned32)(*rB);
    unsigned64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 14007 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.11,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14021 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Condition_Register(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Condition_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Condition_Register

  /* extraction: 0.31,6.RT,11./,16./,21.19,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#line 14041 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3454 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Condition Register\n"));
#line 14047 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Condition_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3454 "./ppc-instructions"
  {
    *rT = (unsigned32)CR;
    PPC_INSN_MFCR(RT_BITMASK);
  }
#line 14061 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,16./,21.19,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#line 14067 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_And_Reserve_Indexed(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_And_Reserve_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_And_Reserve_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.20,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14094 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2423 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word And Reserve Indexed\n"));
#line 14100 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_And_Reserve_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2423 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    RESERVE = 1;
    RESERVE_ADDR = real_addr(EA, 1/*is-read?*/);
    RESERVE_DATA = MEM(unsigned, EA, 4);
    *rT = RESERVE_DATA;
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 14122 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.20,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14135 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero_Indexed(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.23,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14162 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1899 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero Indexed\n"));
#line 14168 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1899 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(unsigned, EA, 4);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 14187 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.23,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14200 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Left_Word_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Left_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Left_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14228 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3251 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Left Word\n"));
#line 14234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Left_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3251 "./ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source << n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu,
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 14259 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14273 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Left_Word_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Left_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Left_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 14301 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3251 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Left Word\n"));
#line 14307 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Left_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3251 "./ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source << n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu,
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 14332 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.24,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14346 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Count_Leading_Zeros_Word_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Count_Leading_Zeros_Word
#undef MY_PREFIX
#define MY_PREFIX Count_Leading_Zeros_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14371 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3130 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Count Leading Zeros Word\n"));
#line 14377 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Count_Leading_Zeros_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3130 "./ppc-instructions"
  {
    int count = 0;
    unsigned32 mask = BIT32(0);
    unsigned32 source = *rS;
    while (!(source & mask) && mask != 0) {
      mask >>= 1;
      count++;
    }
    *rA = count;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    CR0_COMPARE(count, 0, Rc); /* FIXME - is this correct */
  }
#line 14399 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 14410 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Count_Leading_Zeros_Word_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Count_Leading_Zeros_Word
#undef MY_PREFIX
#define MY_PREFIX Count_Leading_Zeros_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 1 /* default in icache - constant field */
#line 14435 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3130 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Count Leading Zeros Word\n"));
#line 14441 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Count_Leading_Zeros_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3130 "./ppc-instructions"
  {
    int count = 0;
    unsigned32 mask = BIT32(0);
    unsigned32 source = *rS;
    while (!(source & mask) && mask != 0) {
      mask >>= 1;
      count++;
    }
    *rA = count;
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    CR0_COMPARE(count, 0, Rc); /* FIXME - is this correct */
  }
#line 14463 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.26,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 14474 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Rc0(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND
#undef MY_PREFIX
#define MY_PREFIX AND_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14502 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3011 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND\n"));
#line 14508 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3011 "./ppc-instructions"
  {
    *rA = *rS & *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 14524 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14538 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_Rc1(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND
#undef MY_PREFIX
#define MY_PREFIX AND_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 14566 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3011 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND\n"));
#line 14572 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3011 "./ppc-instructions"
  {
    *rA = *rS & *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 14588 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.28,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14602 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Compare_Logical(cpu *processor,
                         idecode_cache *cache_entry,
                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Compare_Logical
#undef MY_PREFIX
#define MY_PREFIX Compare_Logical

  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define L cache_entry->crack.X.L /* default in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14629 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2853 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Compare Logical\n"));
#line 14635 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Compare_Logical, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2853 "./ppc-instructions"
  {
    if (!is_64bit_mode && L)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      unsigned_word a;
      unsigned_word b;
      if (L == 0) {
        a = MASKED(*rA, 32, 63);
        b = MASKED(*rB, 32, 63);
      }
      else {
        a = *rA;
        b = *rB;
      }
      CR_COMPARE(BF, a, b);
    }
    PPC_INSN_INT_CR(0, RA_BITMASK | RB_BITMASK, BF_BITMASK);
  }
#line 14664 "semantics.c"
  return nia;
  /* extraction: 0.31,6.BF,9./,10.L,11.RA,16.RB,21.32,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef L
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14677 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE0_Rc0(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 14706 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 14712 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 14730 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 14745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE0_Rc1(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 14774 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 14780 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 14798 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 14813 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Store(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Store
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Store

  /* extraction: 0.31,6./,11.RA,16.RB,21.54,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14837 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4797 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Store\n"));
#line 14843 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Store, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4797 "./ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Store\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 14857 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.54,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14867 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero_with_Update_Indexed(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.55,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 14894 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1926 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero with Update Indexed\n"));
#line 14900 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1926 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(unsigned, EA, 4);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 14920 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.55,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 14933 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_with_Complement_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX AND_with_Complement_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 14961 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3071 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND with Complement\n"));
#line 14967 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3071 "./ppc-instructions"
  {
    *rA = *rS & ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 14983 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 14997 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_AND_with_Complement_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_AND_with_Complement
#undef MY_PREFIX
#define MY_PREFIX AND_with_Complement_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 15025 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3071 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics AND with Complement\n"));
#line 15031 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_AND_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3071 "./ppc-instructions"
  {
    *rA = *rS & ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 15047 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.60,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15061 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Rc0(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 15089 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2716 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word\n"));
#line 15095 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2716 "./ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15114 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15128 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_High_Word_Rc1(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_High_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_High_Word_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 15156 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2716 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply High Word\n"));
#line 15162 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_High_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2716 "./ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = EXTRACTED64(prod, 0, 31);
    *rT = t;
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15181 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21./,22.75,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15195 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Machine_State_Register(cpu *processor,
                                          idecode_cache *cache_entry,
                                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Machine_State_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Machine_State_Register

  /* extraction: 0.31,6.RT,11./,16./,21.83,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#line 15215 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4884 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Machine State Register\n"));
#line 15221 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Machine_State_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4884 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      *rT = MSR;
      check_masked_interrupts(processor);
    }
  }
#line 15240 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,16./,21.83,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#line 15246 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Flush(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Flush
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Flush

  /* extraction: 0.31,6./,11.RA,16.RB,21.86,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 15270 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4805 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Flush\n"));
#line 15276 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Flush, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4805 "./ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Flush\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 15290 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.86,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 15300 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero_Indexed(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.87,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 15327 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1737 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero Indexed\n"));
#line 15333 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1737 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(unsigned, EA, 1);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 15352 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.87,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 15365 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE0_Rc0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 15391 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 15397 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 15414 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 15426 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE0_Rc1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 15452 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 15458 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 15475 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 15487 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero_with_Update_Indexed(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.119,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 15514 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1764 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero with Update Indexed\n"));
#line 15520 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1764 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(unsigned, EA, 1);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 15540 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.119,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 15553 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NOR_Rc0(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NOR
#undef MY_PREFIX
#define MY_PREFIX NOR_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 15581 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3051 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics NOR\n"));
#line 15587 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3051 "./ppc-instructions"
  {
    *rA = ~(*rS | *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 15603 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15617 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NOR_Rc1(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NOR
#undef MY_PREFIX
#define MY_PREFIX NOR_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 15645 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3051 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics NOR\n"));
#line 15651 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3051 "./ppc-instructions"
  {
    *rA = ~(*rS | *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 15667 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.124,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 15681 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE0_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 15710 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 15716 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15734 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15749 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE0_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 15778 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 15784 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15802 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15817 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE0_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 15846 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 15852 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15869 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15884 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE0_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 15913 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 15919 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 15936 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 15951 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Condition_Register_Fields(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_Fields

  /* extraction: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ #define get-values-from-icache */
#define RS cache_entry->crack.XFX.RS /* in icache - extraction */
#define rS cache_entry->crack.XFX.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.XFX.RS_BITMASK /* in icache - extraction */
#define FXM cache_entry->crack.XFX.FXM /* default in icache - extraction */
#line 15972 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3431 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Condition Register Fields\n"));
#line 15978 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Condition_Register_Fields, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3431 "./ppc-instructions"
  {
    if (FXM == 0xff) {
      CR = *rS;
    }
    else {
      unsigned_word mask = 0;
      unsigned_word f;
      for (f = 0; f < 8; f++) {
        if (FXM & (0x80 >> f))
          mask |= (0xf << 4*(7-f));
      }
      CR = (MASKED(*rS, 32, 63) & mask) | (CR & ~mask);
    }
    PPC_INSN_MTCR(RS_BITMASK, FXM);
  }
#line 16003 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,12.FXM,20./,21.144,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef FXM
#line 16010 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_Machine_State_Register(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Machine_State_Register
#undef MY_PREFIX
#define MY_PREFIX Move_To_Machine_State_Register

  /* extraction: 0.31,6.RS,11./,16./,21.146,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#line 16030 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4871 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To Machine State Register\n"));
#line 16036 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_Machine_State_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4871 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      MSR = *rS;
      check_masked_interrupts(processor);
    }
  }
#line 16055 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,16./,21.146,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#line 16061 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_Conditional_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_Conditional_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_Conditional_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.150,31.1 #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16088 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2451 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word Conditional Indexed\n"));
#line 16094 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_Conditional_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2451 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    if (RESERVE) {
      if (RESERVE_ADDR == real_addr(EA, 0/*is-read?*/)
          && /*HACK*/ RESERVE_DATA == MEM(unsigned, EA, 4)) {
        STORE(EA, 4, *rS);
        CR_SET_XER_SO(0, cr_i_zero);
      }
      else {
        /* ment to randomly to store, we never do! */	
        CR_SET_XER_SO(0, 0);
      }
      RESERVE = 0;
    }
    else {
      CR_SET_XER_SO(0, 0);
    }
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 1/*Rc*/);
  }
#line 16127 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.150,31.1 #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_Indexed(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.151,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16167 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2126 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word Indexed\n"));
#line 16173 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2126 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 16192 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.151,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16205 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_with_Update_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_with_Update_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.183,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16232 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2153 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word with Update Indexed\n"));
#line 16238 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2153 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 4, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
  }
#line 16258 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.183,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16271 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE0_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16297 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 16303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16320 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16332 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE0_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16358 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 16364 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16381 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16393 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE0_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16419 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 16425 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16441 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16453 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE0_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16479 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 16485 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16501 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16513 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_Segment_Register(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Segment_Register
#undef MY_PREFIX
#define MY_PREFIX Move_To_Segment_Register

  /* extraction: 0.31,6.RS,11./,12.SR,16./,21.210,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define SR cache_entry->crack.X.SR /* default in icache - extraction */
#line 16534 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4917 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To Segment Register\n"));
#line 16540 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_Segment_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4917 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      SEGREG(SR) = *rS;
  }
#line 16557 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,12.SR,16./,21.210,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef SR
#line 16564 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte_Indexed(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.215,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 16591 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2018 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte Indexed\n"));
#line 16597 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2018 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 1, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 16616 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.215,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 16629 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE0_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16655 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 16661 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16679 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16691 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE0_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16717 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 16723 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16741 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16753 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE0_Rc0(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16779 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 16785 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16802 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16814 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE0_Rc1(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16840 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 16846 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 16863 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 16875 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE0_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 16904 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 16910 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "./ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 16931 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 16946 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE0_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 16975 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 16981 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "./ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 17002 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 17017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_Segment_Register_Indirect(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_Segment_Register_Indirect
#undef MY_PREFIX
#define MY_PREFIX Move_To_Segment_Register_Indirect

  /* extraction: 0.31,6.RS,11./,16.RB,21.242,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17040 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4928 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To Segment Register Indirect\n"));
#line 17046 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_Segment_Register_Indirect, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4928 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      SEGREG(EXTRACTED32(*rB, 0, 3)) = *rS;
  }
#line 17063 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11./,16.RB,21.242,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RB
#undef rB
#undef RB_BITMASK
#line 17072 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Touch_for_Store(cpu *processor,
                                          idecode_cache *cache_entry,
                                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Touch_for_Store
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Touch_for_Store

  /* extraction: 0.31,6./,11.RA,16.RB,21.246,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17096 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4781 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Touch for Store\n"));
#line 17102 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Touch_for_Store, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4781 "./ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Touch for Store\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 17116 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.246,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17126 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte_with_Update_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_with_Update_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.247,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17153 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2045 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte with Update Indexed\n"));
#line 17159 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2045 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 1, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
  }
#line 17179 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.247,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17192 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE0_Rc0(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 17221 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 17227 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 17243 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 17258 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE0_Rc1(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 17287 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 17293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 17309 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 17324 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Touch(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Touch
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Touch

  /* extraction: 0.31,6./,11.RA,16.RB,21.278,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17348 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4773 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Touch\n"));
#line 17354 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Touch, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4773 "./ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block Touch\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 17368 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.278,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17378 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero_Indexed(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.279,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17405 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1791 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero Indexed\n"));
#line 17411 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1791 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(unsigned, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 17430 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.279,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17443 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Equivalent_Rc0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Equivalent_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 17471 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3061 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Equivalent\n"));
#line 17477 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Equivalent, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3061 "./ppc-instructions"
  {
    *rA = ~(*rS ^ *rB); /* A === B */
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17493 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17507 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Equivalent_Rc1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Equivalent
#undef MY_PREFIX
#define MY_PREFIX Equivalent_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 17535 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3061 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Equivalent\n"));
#line 17541 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Equivalent, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3061 "./ppc-instructions"
  {
    *rA = ~(*rS ^ *rB); /* A === B */
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17557 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.284,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17571 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_TLB_Invalidate_Entry(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Invalidate_Entry
#undef MY_PREFIX
#define MY_PREFIX TLB_Invalidate_Entry

  /* extraction: 0.31,6./,11./,16.RB,21.306,31./ #define get-values-from-icache */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17591 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4966 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics TLB Invalidate Entry\n"));
#line 17597 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_TLB_Invalidate_Entry, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4966 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      int nr = 0;
      cpu *proc;
      while (1) {
        proc = psim_cpu(cpu_system(processor), nr);
        if (proc == NULL) break;
        cpu_page_tlb_invalidate_entry(proc, *rB);
        nr++;
      }
    }
  }
#line 17622 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16.RB,21.306,31./ #undef get-values-from-icache */
#undef RB
#undef rB
#undef RB_BITMASK
#line 17628 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero_with_Update_Indexed(cpu *processor,
                                                    idecode_cache *cache_entry,
                                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.311,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 17655 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1818 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero with Update Indexed\n"));
#line 17661 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1818 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(unsigned, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 17681 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.311,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 17694 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Rc0(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR
#undef MY_PREFIX
#define MY_PREFIX XOR_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 17722 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3031 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR\n"));
#line 17728 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3031 "./ppc-instructions"
  {
    *rA = *rS ^ *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17744 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17758 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_XOR_Rc1(cpu *processor,
                 idecode_cache *cache_entry,
                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_XOR
#undef MY_PREFIX
#define MY_PREFIX XOR_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 17786 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3031 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics XOR\n"));
#line 17792 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_XOR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3031 "./ppc-instructions"
  {
    *rA = *rS ^ *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 17808 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.316,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 17822 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_from_Special_Purpose_Register_SPR256(cpu *processor,
                                                   idecode_cache *cache_entry,
                                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_from_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_from_Special_Purpose_Register_SPR256

  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #define get-values-from-icache */
#define RT cache_entry->crack.XFX.RT /* in icache - extraction */
#define rT cache_entry->crack.XFX.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XFX.RT_BITMASK /* in icache - extraction */
#define SPR 256 /* default in icache - constant field */
#line 17843 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3390 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move from Special Purpose Register\n"));
#line 17849 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_from_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3390 "./ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      /* HACK - time base registers need to be calculated */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_dec:
          *rT = cpu_get_decrementer(processor);
          break;
    	case spr_tbrl:
      	  if (is_64bit_implementation) *rT = TB;
      	  else                         *rT = EXTRACTED64(TB, 32, 63);
    	break;
    	case spr_tbru:
      	  if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
    	  else                         *rT = EXTRACTED64(TB, 0, 31);
    	break;
        case spr_tbu:
        case spr_tbl:
          /* NOTE - these SPR's are not readable. Use mftb[ul] */
        default:
          *rT = SPREG(n);
          break;
        }
      }
      else {
        *rT = SPREG(n);
      }
    }
    PPC_INSN_FROM_SPR(RT_BITMASK, n);
  }
#line 17896 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef SPR
#line 17903 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_from_Special_Purpose_Register_SPR(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_from_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_from_Special_Purpose_Register_SPR

  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #define get-values-from-icache */
#define RT cache_entry->crack.XFX.RT /* in icache - extraction */
#define rT cache_entry->crack.XFX.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XFX.RT_BITMASK /* in icache - extraction */
#define SPR cache_entry->crack.XFX.SPR /* default in icache - extraction */
#line 17924 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3390 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move from Special Purpose Register\n"));
#line 17930 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_from_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3390 "./ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      /* HACK - time base registers need to be calculated */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_dec:
          *rT = cpu_get_decrementer(processor);
          break;
    	case spr_tbrl:
      	  if (is_64bit_implementation) *rT = TB;
      	  else                         *rT = EXTRACTED64(TB, 32, 63);
    	break;
    	case spr_tbru:
      	  if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
    	  else                         *rT = EXTRACTED64(TB, 0, 31);
    	break;
        case spr_tbu:
        case spr_tbl:
          /* NOTE - these SPR's are not readable. Use mftb[ul] */
        default:
          *rT = SPREG(n);
          break;
        }
      }
      else {
        *rT = SPREG(n);
      }
    }
    PPC_INSN_FROM_SPR(RT_BITMASK, n);
  }
#line 17977 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.SPR,21.339,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef SPR
#line 17984 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic_Indexed(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.343,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18011 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1845 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic Indexed\n"));
#line 18017 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1845 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = MEM(signed, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 18036 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.343,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18049 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_TLB_Invalidate_All(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Invalidate_All
#undef MY_PREFIX
#define MY_PREFIX TLB_Invalidate_All

  /* extraction: 0.31,6./,11./,16./,21.370,31./ #define get-values-from-icache */
#line 18066 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4981 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics TLB Invalidate All\n"));
#line 18072 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_TLB_Invalidate_All, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4981 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else {
      int nr = 0;
      cpu *proc;
      while (1) {
        proc = psim_cpu(cpu_system(processor), nr);
        if (proc == NULL) break;
        cpu_page_tlb_invalidate_all(proc);
        nr++;
      }
    }
  }
#line 18097 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.370,31./ #undef get-values-from-icache */
#line 18100 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Time_Base(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Time_Base
#undef MY_PREFIX
#define MY_PREFIX Move_From_Time_Base

  /* extraction: 0.31,6.RT,11.tbr,21.371,31./ #define get-values-from-icache */
#define RT cache_entry->crack.XFX.RT /* in icache - extraction */
#define rT cache_entry->crack.XFX.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XFX.RT_BITMASK /* in icache - extraction */
#define tbr cache_entry->crack.XFX.tbr /* default in icache - extraction */
#line 18121 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 4824 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Time Base\n"));
#line 18127 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Time_Base, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4824 "./ppc-instructions"
  {
    int n = (tbr_5_9_ << 5) | tbr_0_4_;
    if (n == 268) {
      if (is_64bit_implementation) *rT = TB;
      else                         *rT = EXTRACTED64(TB, 32, 63);
    }
    else if (n == 269) {
      if (is_64bit_implementation) *rT = EXTRACTED64(TB, 0, 31);
      else                         *rT = EXTRACTED64(TB, 0, 31);
    }
    else
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
  }
#line 18151 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.tbr,21.371,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef tbr
#line 18158 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic_with_Update_Indexed(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_with_Update_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.375,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18185 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 1872 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic with Update Indexed\n"));
#line 18191 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1872 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *rT = MEM(signed, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK | RB_BITMASK, 0);
  }
#line 18211 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.375,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18224 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_Indexed(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.407,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18251 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2072 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word Indexed\n"));
#line 18257 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2072 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 2, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 18276 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.407,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18289 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_with_Complement_Rc0(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX OR_with_Complement_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 18317 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3081 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR with Complement\n"));
#line 18323 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3081 "./ppc-instructions"
  {
    *rA = *rS | ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18339 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18353 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_with_Complement_Rc1(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR_with_Complement
#undef MY_PREFIX
#define MY_PREFIX OR_with_Complement_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 18381 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3081 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR with Complement\n"));
#line 18387 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR_with_Complement, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3081 "./ppc-instructions"
  {
    *rA = *rS | ~*rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18403 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.412,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18417 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_with_Update_Indexed(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_with_Update_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.439,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18444 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2099 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word with Update Indexed\n"));
#line 18450 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2099 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 2, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RB_BITMASK | RS_BITMASK, 0);
  }
#line 18470 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.439,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18483 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Rc0(cpu *processor,
                idecode_cache *cache_entry,
                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR
#undef MY_PREFIX
#define MY_PREFIX OR_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 18511 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3021 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR\n"));
#line 18517 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3021 "./ppc-instructions"
  {
    *rA = *rS | *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18533 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18547 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_OR_Rc1(cpu *processor,
                idecode_cache *cache_entry,
                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_OR
#undef MY_PREFIX
#define MY_PREFIX OR_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 18575 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3021 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics OR\n"));
#line 18581 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_OR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3021 "./ppc-instructions"
  {
    *rA = *rS | *rB;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 18597 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.444,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 18611 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE0_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 18640 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 18646 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "./ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 18671 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 18686 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE0_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 18715 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 18721 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "./ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 18746 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 18761 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Special_Purpose_Register_SPR256(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_to_Special_Purpose_Register_SPR256

  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #define get-values-from-icache */
#define RS cache_entry->crack.XFX.RS /* in icache - extraction */
#define rS cache_entry->crack.XFX.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.XFX.RS_BITMASK /* in icache - extraction */
#define SPR 256 /* default in icache - constant field */
#line 18782 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3346 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Special Purpose Register\n"));
#line 18788 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3346 "./ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n)
             || spr_is_readonly(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      spreg new_val = (spr_length(n) == 64
    		   ? *rS
    		   : MASKED(*rS, 32, 63));
      /* HACK - time base registers need to be updated immediatly */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_tbu:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 32, 63)
                             | INSERTED64(new_val, 0, 31)));
          break;
        case spr_tbl:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 0, 31)
                             | INSERTED64(new_val, 32, 63)));
          break;
        case spr_dec:
          cpu_set_decrementer(processor, new_val);
          break;
        default:
          SPREG(n) = new_val;
          break;
        }
      }
      else {
        SPREG(n) = new_val;
      }
    }
    PPC_INSN_TO_SPR(RS_BITMASK, n);
  }
#line 18838 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef SPR
#line 18845 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Special_Purpose_Register_SPR(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Special_Purpose_Register
#undef MY_PREFIX
#define MY_PREFIX Move_to_Special_Purpose_Register_SPR

  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #define get-values-from-icache */
#define RS cache_entry->crack.XFX.RS /* in icache - extraction */
#define rS cache_entry->crack.XFX.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.XFX.RS_BITMASK /* in icache - extraction */
#define SPR cache_entry->crack.XFX.SPR /* default in icache - extraction */
#line 18866 "semantics.c"

#define insn cache_entry->crack.XFX.insn
  unsigned_word nia;
#line 3346 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Special Purpose Register\n"));
#line 18872 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Special_Purpose_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3346 "./ppc-instructions"
  {
    int n = (SPR_5_9_ << 5) | SPR_0_4_;
    if (SPR_0_ && IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else if (!spr_is_valid(n)
             || spr_is_readonly(n))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    else {
      spreg new_val = (spr_length(n) == 64
    		   ? *rS
    		   : MASKED(*rS, 32, 63));
      /* HACK - time base registers need to be updated immediatly */
      if (WITH_TIME_BASE) {
        switch (n) {
        case spr_tbu:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 32, 63)
                             | INSERTED64(new_val, 0, 31)));
          break;
        case spr_tbl:
          cpu_set_time_base(processor,
                            (MASKED64(cpu_get_time_base(processor), 0, 31)
                             | INSERTED64(new_val, 32, 63)));
          break;
        case spr_dec:
          cpu_set_decrementer(processor, new_val);
          break;
        default:
          SPREG(n) = new_val;
          break;
        }
      }
      else {
        SPREG(n) = new_val;
      }
    }
    PPC_INSN_TO_SPR(RS_BITMASK, n);
  }
#line 18922 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.SPR,21.467,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef SPR
#line 18929 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_Invalidate(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_Invalidate
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_Invalidate

  /* extraction: 0.31,6./,11.RA,16.RB,21.470,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 18953 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4902 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block Invalidate\n"));
#line 18959 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_Invalidate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4902 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      TRACE(trace_tbd,("Data Cache Block Invalidate\n"));
  }
#line 18976 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.470,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 18986 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NAND_Rc0(cpu *processor,
                  idecode_cache *cache_entry,
                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NAND
#undef MY_PREFIX
#define MY_PREFIX NAND_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 19014 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3041 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics NAND\n"));
#line 19020 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NAND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3041 "./ppc-instructions"
  {
    *rA = ~(*rS & *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 19036 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19050 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_NAND_Rc1(cpu *processor,
                  idecode_cache *cache_entry,
                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_NAND
#undef MY_PREFIX
#define MY_PREFIX NAND_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 19078 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3041 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics NAND\n"));
#line 19084 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_NAND, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3041 "./ppc-instructions"
  {
    *rA = ~(*rS & *rB);
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK | RB_BITMASK, Rc);
  }
#line 19100 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.476,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19114 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE0_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE0_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19143 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 19149 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "./ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19175 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19190 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE0_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE0_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 0 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 19219 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 19225 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "./ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19251 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19266 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Condition_Register_from_XER(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_from_XER
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_from_XER

  /* extraction: 0.31,6.BF,9./,11./,16./,21.512,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#line 19285 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3446 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Condition Register from XER\n"));
#line 19291 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Condition_Register_from_XER, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3446 "./ppc-instructions"
  error("%s:%d:0x%08lx:%s unimplemented\n",
        itable[MY_INDEX].file, itable[MY_INDEX].line_nr, (long)cia, itable[MY_INDEX].name);
#line 19303 "semantics.c"
  return nia;
  /* extraction: 0.31,6.BF,9./,11./,16./,21.512,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#line 19308 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE1_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19337 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 19343 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "./ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19362 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19377 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Carrying_OE1_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Carrying
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Carrying_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 19406 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2597 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Carrying\n"));
#line 19412 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2597 "./ppc-instructions"
  {
    /* RT <- ~RA + RB + 1 === RT <- RB - RA */
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19431 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.8,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19446 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE1_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19475 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 19481 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19497 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19512 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Carrying_OE1_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Carrying
#undef MY_PREFIX
#define MY_PREFIX Add_Carrying_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 19541 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2587 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Carrying\n"));
#line 19547 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Carrying, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2587 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19563 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.10,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 19578 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_String_Word_Indexed(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_String_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_String_Word_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.533,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 19605 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2329 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load String Word Indexed\n"));
#line 19611 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_String_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2329 "./ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int n;
    int r;
    int i;
    int nr;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    n = EXTRACTED32(XER, 25, 31);
    r = RT - 1;
    i = 32;
    nr = (n + 3) / 4;
    if (((RT + nr >= 32)
         ? ((RA >= RT || RA < (RT + nr) % 32)
            || (RB >= RT || RB < (RT + nr) % 32))
         : ((RA >= RT && RA < RT + nr)
            || (RB >= RT && RB < RT + nr)))
        || (RT == RA || RT == RB))
      program_interrupt(processor, cia,
                      illegal_instruction_program_interrupt);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    while (n > 0) {
      if (i == 32) {
        r = (r + 1) % 32;
        GPR(r) = 0;
      }
      GPR(r) |= INSERTED(MEM(unsigned, EA, 1), i, i+7);
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 19657 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.533,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 19670 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_ByteReverse_Indexed(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_ByteReverse_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Word_ByteReverse_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.534,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 19697 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2216 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word Byte-Reverse Indexed\n"));
#line 19703 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_ByteReverse_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2216 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = SWAP_4(MEM(unsigned, EA, 4));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 19722 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.534,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 19735 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single_Indexed(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.535,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 19761 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3479 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single Indexed\n"));
#line 19767 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3479 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 19786 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.535,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 19798 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Word_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 19826 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3272 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Word\n"));
#line 19832 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3272 "./ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source >> n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, \
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 19857 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19871 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Word_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 19899 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3272 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Word\n"));
#line 19905 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3272 "./ppc-instructions"
  {
    int n = MASKED(*rB, 58, 63);
    unsigned32 source = *rS;
    signed_word shifted;
    if (n < 32)
      shifted = (source >> n);
    else
      shifted = 0;
    *rA = shifted;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, \
           ("n=%d, source=0x%lx, shifted=0x%lx\n",
            n, (unsigned long)source, (unsigned long)shifted));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 19930 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.536,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 19944 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE1_Rc0(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 19973 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 19979 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 19997 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20012 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_OE1_Rc1(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20041 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2543 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From\n"));
#line 20047 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2543 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD(1);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20065 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.40,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20080 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_TLB_Synchronize(cpu *processor,
                         idecode_cache *cache_entry,
                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_TLB_Synchronize
#undef MY_PREFIX
#define MY_PREFIX TLB_Synchronize

  /* extraction: 0.31,6./,11./,16./,21.566,31./ #define get-values-from-icache */
#line 20097 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4996 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics TLB Synchronize\n"));
#line 20103 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_TLB_Synchronize, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4996 "./ppc-instructions"
  {
    /* nothing happens here - always in sync */
  }
#line 20116 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.566,31./ #undef get-values-from-icache */
#line 20119 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single_with_Update_Indexed(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_with_Update_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.567,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20145 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3506 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single with Update Indexed\n"));
#line 20151 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3506 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 20171 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.567,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20183 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Segment_Register(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Segment_Register
#undef MY_PREFIX
#define MY_PREFIX Move_From_Segment_Register

  /* extraction: 0.31,6.RT,11./,12.SR,16./,21.595,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define SR cache_entry->crack.X.SR /* default in icache - extraction */
#line 20204 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4939 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Segment Register\n"));
#line 20210 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Segment_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4939 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      *rT = SEGREG(SR);
  }
#line 20227 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,12.SR,16./,21.595,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef SR
#line 20234 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_String_Word_Immediate(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_String_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Load_String_Word_Immediate

  /* extraction: 0.31,6.RT,11.RA,16.NB,21.597,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define NB cache_entry->crack.X.NB /* default in icache - extraction */
#line 20259 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2297 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load String Word Immediate\n"));
#line 20265 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_String_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2297 "./ppc-instructions"
  {
    unsigned_word EA;
    int n;
    int r;
    int i;
    int nr;
    if (RA_is_0) EA = 0;
    else         EA = *rA;
    if (NB == 0) n = 32;
    else         n = NB;
    r = RT - 1;
    i = 32;
    nr = (n + 3) / 4;
    if ((RT + nr >= 32)
        ? (RA >= RT || RA < (RT + nr) % 32)
        : (RA >= RT && RA < RT + nr))
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    while (n > 0) {
      if (i == 32) {
        r = (r + 1) % 32;
        GPR(r) = 0;
      }
      GPR(r) |= INSERTED(MEM(unsigned, EA, 1), i, i+7);
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 20307 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.NB,21.597,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef NB
#line 20318 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Synchronize(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Synchronize
#undef MY_PREFIX
#define MY_PREFIX Synchronize

  /* extraction: 0.31,6./,9.L,11./,16./,21.598,31./ #define get-values-from-icache */
#define L cache_entry->crack.X.L /* default in icache - extraction */
#line 20336 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2501 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Synchronize\n"));
#line 20342 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Synchronize, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2501 "./ppc-instructions"
  {
    /* do nothing */
  }
#line 20355 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,9.L,11./,16./,21.598,31./ #undef get-values-from-icache */
#undef L
#line 20359 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double_Indexed(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.599,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20385 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3533 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double Indexed\n"));
#line 20391 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3533 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *frT = MEM(unsigned, EA, 8);
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 20410 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.599,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20422 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE1_Rc0(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 20448 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 20454 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 20471 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 20483 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Negate_OE1_Rc1(cpu *processor,
                        idecode_cache *cache_entry,
                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Negate
#undef MY_PREFIX
#define MY_PREFIX Negate_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20509 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2677 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Negate\n"));
#line 20515 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2677 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(1);
    ALU_END(*rT,0/*CA*/,OE,Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 20532 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.104,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 20544 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double_with_Update_Indexed(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_with_Update_Indexed

  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.631,31./ #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20570 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3560 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double with Update Indexed\n"));
#line 20576 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3560 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    *frT = MEM(unsigned, EA, 8);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 20596 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRT,11.RA,16.RB,21.631,31./ #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 20608 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE1_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 20637 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 20643 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20661 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20676 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Extended_OE1_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20705 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2621 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Extended\n"));
#line 20711 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2621 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20729 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.136,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20744 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE1_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 20773 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 20779 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20796 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20811 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_Extended_OE1_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 20840 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2610 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add Extended\n"));
#line 20846 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2610 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 20863 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.138,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 20878 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_Segment_Register_Indirect(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_Segment_Register_Indirect
#undef MY_PREFIX
#define MY_PREFIX Move_From_Segment_Register_Indirect

  /* extraction: 0.31,6.RT,11./,16.RB,21.659,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20901 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4950 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From Segment Register Indirect\n"));
#line 20907 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_Segment_Register_Indirect, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4950 "./ppc-instructions"
  {
    if (IS_PROBLEM_STATE(processor))
      program_interrupt(processor, cia,
                        privileged_instruction_program_interrupt);
    else
      *rT = SEGREG(EXTRACTED32(*rB, 0, 3));
  }
#line 20924 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11./,16.RB,21.659,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RB
#undef rB
#undef RB_BITMASK
#line 20933 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_String_Word_Indexed(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_String_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_String_Word_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.661,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 20960 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2387 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store String Word Indexed\n"));
#line 20966 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_String_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2387 "./ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int n;
    int r;
    int i;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    n = EXTRACTED32(XER, 25, 31);
    r = RS - 1;
    i = 32;
    while (n > 0) {
      if (i == 32) r = (r + 1) % 32;
      STORE(EA, 1, EXTRACTED(GPR(r), i, i+7));
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 20999 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.661,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21012 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_ByteReversed_Indexed(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_ByteReversed_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Word_ByteReversed_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.662,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21039 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2242 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word Byte-Reversed Indexed\n"));
#line 21045 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_ByteReversed_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2242 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, SWAP_4(*rS));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 21064 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.662,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21077 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single_Indexed(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.663,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21103 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3592 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single Indexed\n"));
#line 21109 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3592 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, SINGLE(*frS));
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 21128 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.663,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21140 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single_with_Update_Indexed(cpu *processor,
                                                        idecode_cache *cache_entry,
                                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_with_Update_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.695,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21166 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3619 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single with Update Indexed\n"));
#line 21172 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3619 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 4, SINGLE(*frS));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 21192 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.695,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21204 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE1_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21230 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 21236 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21253 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21265 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_from_Zero_Extended_OE1_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_from_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_from_Zero_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21291 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2666 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract from Zero Extended\n"));
#line 21297 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_from_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2666 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21314 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.200,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21326 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE1_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21352 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 21358 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21374 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21386 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Zero_Extended_OE1_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Zero_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Zero_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21412 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2656 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Zero Extended\n"));
#line 21418 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Zero_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2656 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21434 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.202,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21446 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_String_Word_Immedate(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_String_Word_Immedate
#undef MY_PREFIX
#define MY_PREFIX Store_String_Word_Immedate

  /* extraction: 0.31,6.RS,11.RA,16.NB,21.725,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define NB cache_entry->crack.X.NB /* default in icache - extraction */
#line 21471 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2365 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store String Word Immedate\n"));
#line 21477 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_String_Word_Immedate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2365 "./ppc-instructions"
  {
    unsigned_word EA;
    int n;
    int r;
    int i;
    if (RA_is_0) EA = 0;
    else         EA = *rA;
    if (NB == 0) n = 32;
    else         n = NB;
    r = RS - 1;
    i = 32;
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT)
      alignment_interrupt(processor, cia, EA);
    while (n > 0) {
      if (i == 32) r = (r + 1) % 32;
      STORE(EA, 1, EXTRACTED(GPR(r), i, i+7));
      i = i + 8;
      if (i == 64) i = 32;
      EA = EA + 1;
      n = n - 1;
    }
  }
#line 21509 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.NB,21.725,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef NB
#line 21520 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double_Indexed(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.727,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21546 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3646 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double Indexed\n"));
#line 21552 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3646 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 8, *frS);
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 21571 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.727,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 21583 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE1_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21609 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 21615 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21633 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21645 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Subtract_From_Minus_One_Extended_OE1_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Subtract_From_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Subtract_From_Minus_One_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21671 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2644 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Subtract From Minus One Extended\n"));
#line 21677 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Subtract_From_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2644 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_NOT;
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21695 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.232,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21707 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE1_Rc0(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21733 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 21739 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21756 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21768 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_to_Minus_One_Extended_OE1_Rc1(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add_to_Minus_One_Extended
#undef MY_PREFIX
#define MY_PREFIX Add_to_Minus_One_Extended_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21794 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2633 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add to Minus One Extended\n"));
#line 21800 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add_to_Minus_One_Extended, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2633 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD_CA;
    ALU_ADD(-1);
    ALU_END(*rT, 1/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK, Rc);
  }
#line 21817 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16./,21.OE,22.234,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef OE
#undef Rc
#line 21829 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE1_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 21858 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 21864 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "./ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 21885 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 21900 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Multiply_Low_Word_OE1_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Multiply_Low_Word
#undef MY_PREFIX
#define MY_PREFIX Multiply_Low_Word_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 21929 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2699 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Multiply Low Word\n"));
#line 21935 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Multiply_Low_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2699 "./ppc-instructions"
  {
    signed64 a = (signed32)(*rA);
    signed64 b = (signed32)(*rB);
    signed64 prod = a * b;
    signed_word t = prod;
    *rT = *rA * *rB;
    if (t != prod && OE)
      XER |= (xer_overflow | xer_summary_overflow);
    CR0_COMPARE(t, 0, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 21956 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.235,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 21971 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double_with_Update_Indexed(cpu *processor,
                                                        idecode_cache *cache_entry,
                                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_with_Update_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_with_Update_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.759,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 21997 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3685 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double with Update Indexed\n"));
#line 22003 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double_with_Update_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3685 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + *rB;
    STORE(EA, 8, *frS);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 22023 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.759,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 22035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE1_Rc0(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 22064 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 22070 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22086 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 22101 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Add_OE1_Rc1(cpu *processor,
                     idecode_cache *cache_entry,
                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Add
#undef MY_PREFIX
#define MY_PREFIX Add_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 22130 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2533 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Add\n"));
#line 22136 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2533 "./ppc-instructions"
  {
    ALU_BEGIN(*rA);
    ALU_ADD(*rB);
    ALU_END(*rT, 0/*CA*/, OE, Rc);
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22152 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.266,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 22167 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_ByteReverse_Indexed(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_ByteReverse_Indexed
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_ByteReverse_Indexed

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.790,31./ #define get-values-from-icache */
#define RT cache_entry->crack.X.RT /* in icache - extraction */
#define rT cache_entry->crack.X.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.X.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 22194 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2203 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Byte-Reverse Indexed\n"));
#line 22200 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_ByteReverse_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2203 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    *rT = SWAP_2(MEM(unsigned, EA, 2));
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 22219 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.790,31./ #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 22232 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22260 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3315 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word\n"));
#line 22266 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3315 "./ppc-instructions"
  {
    unsigned64 mask;
    int n = MASKED(*rB, 59, 63);
    signed32 source = (signed32)*rS; /* signed to keep sign bit */
    signed32 shifted = source >> n;
    int S = (MASKED(*rS,32,32) != 0);
    signed64 r = ((unsigned64) source);
    r = ((unsigned64) source) << 32 | (unsigned32) source;
    r = ROTL64(r,64-n);
    if (MASKED(*rB,58,58) == 0)
    	mask = (unsigned64) MASK64(n+32,63);
    else
    	mask = (unsigned64) 0;
    *rA = (signed_word) (r & mask | ((signed64) -1*S) & ~mask); /* if 64bit will sign extend */
    if (S && (MASKED(r & ~mask,32,63)!=0))
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22299 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 22313 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22341 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3315 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word\n"));
#line 22347 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3315 "./ppc-instructions"
  {
    unsigned64 mask;
    int n = MASKED(*rB, 59, 63);
    signed32 source = (signed32)*rS; /* signed to keep sign bit */
    signed32 shifted = source >> n;
    int S = (MASKED(*rS,32,32) != 0);
    signed64 r = ((unsigned64) source);
    r = ((unsigned64) source) << 32 | (unsigned32) source;
    r = ROTL64(r,64-n);
    if (MASKED(*rB,58,58) == 0)
    	mask = (unsigned64) MASK64(n+32,63);
    else
    	mask = (unsigned64) 0;
    *rA = (signed_word) (r & mask | ((signed64) -1*S) & ~mask); /* if 64bit will sign extend */
    if (S && (MASKED(r & ~mask,32,63)!=0))
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22380 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.792,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef Rc
#line 22394 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Immediate_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Immediate_Rc0

  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.X.SH /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22420 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3293 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word Immediate\n"));
#line 22426 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3293 "./ppc-instructions"
  {
    int n = SH;
    signed_word r = ROTL32(*rS, /*64*/32-n);
    signed_word m = MASK(n+32, 63);
    int S = MASKED(*rS, 32, 32);
    signed_word shifted = (r & m) | (S ? ~m : 0);
    *rA = shifted;
    if (S && ((r & ~m) & MASK(32, 63)) != 0)
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22452 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef Rc
#line 22464 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Shift_Right_Algebraic_Word_Immediate_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Shift_Right_Algebraic_Word_Immediate
#undef MY_PREFIX
#define MY_PREFIX Shift_Right_Algebraic_Word_Immediate_Rc1

  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define SH cache_entry->crack.X.SH /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22490 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3293 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Shift Right Algebraic Word Immediate\n"));
#line 22496 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Shift_Right_Algebraic_Word_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3293 "./ppc-instructions"
  {
    int n = SH;
    signed_word r = ROTL32(*rS, /*64*/32-n);
    signed_word m = MASK(n+32, 63);
    int S = MASKED(*rS, 32, 32);
    signed_word shifted = (r & m) | (S ? ~m : 0);
    *rA = shifted;
    if (S && ((r & ~m) & MASK(32, 63)) != 0)
      XER |= xer_carry;
    else
      XER &= ~xer_carry;
    CR0_COMPARE(shifted, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx), XER = %ld\n",
    		   (long)*rA, (long)*rA, (long)XER));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22522 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.SH,21.824,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef SH
#undef Rc
#line 22534 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Enforce_Inorder_Execution_of_IO(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Enforce_Inorder_Execution_of_IO
#undef MY_PREFIX
#define MY_PREFIX Enforce_Inorder_Execution_of_IO

  /* extraction: 0.31,6./,11./,16./,21.854,31./ #define get-values-from-icache */
#line 22551 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4813 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Enforce In-order Execution of I/O\n"));
#line 22557 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Enforce_Inorder_Execution_of_IO, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4813 "./ppc-instructions"
  {
    /* Since this model has no instruction overlap
       this instruction need do nothing */
  }
#line 22571 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11./,16./,21.854,31./ #undef get-values-from-icache */
#line 22574 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_ByteReversed_Indexed(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_ByteReversed_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_ByteReversed_Indexed

  /* extraction: 0.31,6.RS,11.RA,16.RB,21.918,31./ #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 22601 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 2229 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word Byte-Reversed Indexed\n"));
#line 22607 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_ByteReversed_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2229 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 2, SWAP_2(*rS));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK | RS_BITMASK, 0);
  }
#line 22626 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16.RB,21.918,31./ #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 22639 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Half_Word_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Half_Word_Rc0

  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22664 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3101 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Half Word\n"));
#line 22670 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Half_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3101 "./ppc-instructions"
  {
    *rA = (signed_word)(signed16)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22686 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22697 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Half_Word_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Half_Word_Rc1

  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22722 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3101 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Half Word\n"));
#line 22728 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Half_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3101 "./ppc-instructions"
  {
    *rA = (signed_word)(signed16)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22744 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.922,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22755 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Byte_Rc0(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Byte
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Byte_Rc0

  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 0 /* default in icache - constant field */
#line 22780 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3091 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Byte\n"));
#line 22786 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Byte, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3091 "./ppc-instructions"
  {
    *rA = (signed_word)(signed8)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22802 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22813 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Extend_Sign_Byte_Rc1(cpu *processor,
                              idecode_cache *cache_entry,
                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Extend_Sign_Byte
#undef MY_PREFIX
#define MY_PREFIX Extend_Sign_Byte_Rc1

  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #define get-values-from-icache */
#define RS cache_entry->crack.X.RS /* in icache - extraction */
#define rS cache_entry->crack.X.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.X.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define Rc 1 /* default in icache - constant field */
#line 22838 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3091 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Extend Sign Byte\n"));
#line 22844 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Extend_Sign_Byte, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3091 "./ppc-instructions"
  {
    *rA = (signed_word)(signed8)*rS;
    CR0_COMPARE(*rA, 0, Rc);
    ITRACE(trace_alu, (" Result = %ld (0x%lx)\n", (long)*rA, (long)*rA));
    PPC_INSN_INT(RA_BITMASK, RS_BITMASK, Rc);
  }
#line 22860 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RS,11.RA,16./,21.954,31.Rc #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef Rc
#line 22871 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE1_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 22900 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 22906 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "./ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 22931 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 22946 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_Unsigned_OE1_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word_Unsigned
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_Unsigned_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 22975 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2768 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word Unsigned\n"));
#line 22981 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word_Unsigned, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2768 "./ppc-instructions"
  {
    unsigned64 dividend = (unsigned32)(*rA);
    unsigned64 divisor = (unsigned32)(*rB);
    if (divisor == 0) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      unsigned64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 23006 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.459,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 23021 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Instruction_Cache_Block_Invalidate(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Instruction_Cache_Block_Invalidate
#undef MY_PREFIX
#define MY_PREFIX Instruction_Cache_Block_Invalidate

  /* extraction: 0.31,6./,11.RA,16.RB,21.982,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 23045 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4749 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Instruction Cache Block Invalidate\n"));
#line 23051 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Instruction_Cache_Block_Invalidate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4749 "./ppc-instructions"
  {
    /* blindly flush all instruction cache entries */
#if WITH_IDECODE_CACHE_SIZE
    cpu_flush_icache(processor);
#endif
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0);
  }
#line 23068 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.982,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 23078 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Integer_Word_Indexed(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Integer_Word_Indexed
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Integer_Word_Indexed

  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.983,31./ #define get-values-from-icache */
#define frS cache_entry->crack.X.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.X.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 23104 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3658 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Integer Word Indexed\n"));
#line 23110 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Integer_Word_Indexed, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3658 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + *rB;
    STORE(EA, 4, *frS);
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1) | RB_BITMASK, FRS_BITMASK);
  }
#line 23129 "semantics.c"
  return nia;
  /* extraction: 0.31,6.FRS,11.RA,16.RB,21.983,31./ #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 23141 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE1_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE1_Rc0

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 0 /* default in icache - constant field */
#line 23170 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 23176 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "./ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 23202 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 23217 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Divide_Word_OE1_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Divide_Word
#undef MY_PREFIX
#define MY_PREFIX Divide_Word_OE1_Rc1

  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #define get-values-from-icache */
#define RT cache_entry->crack.XO.RT /* in icache - extraction */
#define rT cache_entry->crack.XO.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.XO.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.XO.RA /* in icache - extraction */
#define rA cache_entry->crack.XO.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.XO.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.XO.RB /* in icache - extraction */
#define rB cache_entry->crack.XO.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.XO.RB_BITMASK /* in icache - extraction */
#define OE 1 /* default in icache - constant field */
#define Rc 1 /* default in icache - constant field */
#line 23246 "semantics.c"

#define insn cache_entry->crack.XO.insn
  unsigned_word nia;
#line 2746 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Divide Word\n"));
#line 23252 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Divide_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2746 "./ppc-instructions"
  {
    signed64 dividend = (signed32)(*rA);
    signed64 divisor = (signed32)(*rB);
    if (divisor == 0 /* nb 0x8000..0 is sign extended */
        || (dividend == 0x80000000 && divisor == -1)) {
      if (OE)
        XER |= (xer_overflow | xer_summary_overflow);
      CR0_COMPARE(0, 0, Rc);
    }
    else {
      signed64 quotent = dividend / divisor;
      *rT = quotent;
      CR0_COMPARE((signed_word)quotent, 0, Rc);
    }
    PPC_INSN_INT(RT_BITMASK, RA_BITMASK | RB_BITMASK, Rc);
  }
#line 23278 "semantics.c"
  return nia;
  /* extraction: 0.31,6.RT,11.RA,16.RB,21.OE,22.491,31.Rc #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#undef OE
#undef Rc
#line 23293 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Data_Cache_Block_set_to_Zero(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Data_Cache_Block_set_to_Zero
#undef MY_PREFIX
#define MY_PREFIX Data_Cache_Block_set_to_Zero

  /* extraction: 0.31,6./,11.RA,16.RB,21.1014,31./ #define get-values-from-icache */
#define RA cache_entry->crack.X.RA /* in icache - extraction */
#define rA cache_entry->crack.X.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.X.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define RB cache_entry->crack.X.RB /* in icache - extraction */
#define rB cache_entry->crack.X.rB /* in icache - extraction */
#define RB_BITMASK cache_entry->crack.X.RB_BITMASK /* in icache - extraction */
#line 23317 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4789 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Data Cache Block set to Zero\n"));
#line 23323 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Data_Cache_Block_set_to_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4789 "./ppc-instructions"
  {
    TRACE(trace_tbd,("Data Cache Block set to Zero\n"));
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RB_BITMASK, 0/*Rc*/);
  }
#line 23337 "semantics.c"
  return nia;
  /* extraction: 0.31,6./,11.RA,16.RB,21.1014,31./ #undef get-values-from-icache */
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef RB
#undef rB
#undef RB_BITMASK
#line 23347 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero

  /* extraction: 0.32,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23372 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1886 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero\n"));
#line 23378 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1886 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(unsigned, EA, 4);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23397 "semantics.c"
  return nia;
  /* extraction: 0.32,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23408 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Word_and_Zero_with_Update(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Word_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Word_and_Zero_with_Update

  /* extraction: 0.33,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23433 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1912 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Word and Zero with Update\n"));
#line 23439 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Word_and_Zero_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1912 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(unsigned, EA, 4);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 23459 "semantics.c"
  return nia;
  /* extraction: 0.33,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23470 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero

  /* extraction: 0.34,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23495 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1723 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero\n"));
#line 23501 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1723 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(unsigned, EA, 1);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23520 "semantics.c"
  return nia;
  /* extraction: 0.34,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23531 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Byte_and_Zero_with_Update(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Byte_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Byte_and_Zero_with_Update

  /* extraction: 0.35,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23556 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1750 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Byte and Zero with Update\n"));
#line 23562 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Byte_and_Zero_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1750 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(unsigned, EA, 1);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 23582 "semantics.c"
  return nia;
  /* extraction: 0.35,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23593 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word(cpu *processor,
                    idecode_cache *cache_entry,
                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Word

  /* extraction: 0.36,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23618 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2113 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word\n"));
#line 23624 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2113 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 4, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
  }
#line 23643 "semantics.c"
  return nia;
  /* extraction: 0.36,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23654 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Word_with_Update(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Word_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Word_with_Update

  /* extraction: 0.37,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23679 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2139 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Word with Update\n"));
#line 23685 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Word_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2139 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 4, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
  }
#line 23705 "semantics.c"
  return nia;
  /* extraction: 0.37,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23716 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte(cpu *processor,
                    idecode_cache *cache_entry,
                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte
#undef MY_PREFIX
#define MY_PREFIX Store_Byte

  /* extraction: 0.38,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23741 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2005 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte\n"));
#line 23747 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2005 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 1, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
  }
#line 23766 "semantics.c"
  return nia;
  /* extraction: 0.38,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23777 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Byte_with_Update(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Byte_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Byte_with_Update

  /* extraction: 0.39,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23802 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2031 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Byte with Update\n"));
#line 23808 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Byte_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2031 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 1, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
  }
#line 23828 "semantics.c"
  return nia;
  /* extraction: 0.39,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23839 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero(cpu *processor,
                                idecode_cache *cache_entry,
                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero

  /* extraction: 0.40,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23864 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1778 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero\n"));
#line 23870 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1778 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(unsigned, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 23889 "semantics.c"
  return nia;
  /* extraction: 0.40,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23900 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_and_Zero_with_Update(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_and_Zero_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_and_Zero_with_Update

  /* extraction: 0.41,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23925 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1804 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword and Zero with Update\n"));
#line 23931 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_and_Zero_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1804 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(unsigned, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 23951 "semantics.c"
  return nia;
  /* extraction: 0.41,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 23962 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic

  /* extraction: 0.42,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 23987 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1832 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic\n"));
#line 23993 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1832 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *rT = MEM(signed, EA, 2);
    PPC_INSN_INT(RT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24012 "semantics.c"
  return nia;
  /* extraction: 0.42,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24023 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Halfword_Algebraic_with_Update(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Halfword_Algebraic_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_Halfword_Algebraic_with_Update

  /* extraction: 0.43,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24048 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 1858 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Halfword Algebraic with Update\n"));
#line 24054 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Halfword_Algebraic_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 1858 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0 || RA == RT)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *rT = MEM(signed, EA, 2);
    *rA = EA;
    PPC_INSN_INT(RT_BITMASK | RA_BITMASK, RA_BITMASK, 0);
  }
#line 24074 "semantics.c"
  return nia;
  /* extraction: 0.43,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24085 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word(cpu *processor,
                         idecode_cache *cache_entry,
                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word

  /* extraction: 0.44,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24110 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2059 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word\n"));
#line 24116 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2059 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 2, *rS);
    PPC_INSN_INT(0, (RA_BITMASK & ~1) | RS_BITMASK, 0);
  }
#line 24135 "semantics.c"
  return nia;
  /* extraction: 0.44,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24146 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Half_Word_with_Update(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Half_Word_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_Half_Word_with_Update

  /* extraction: 0.45,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24171 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2085 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Half Word with Update\n"));
#line 24177 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Half_Word_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2085 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 2, *rS);
    *rA = EA;
    PPC_INSN_INT(RA_BITMASK, RA_BITMASK | RS_BITMASK, 0);
  }
#line 24197 "semantics.c"
  return nia;
  /* extraction: 0.45,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24208 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_Multiple_Word(cpu *processor,
                            idecode_cache *cache_entry,
                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_Multiple_Word
#undef MY_PREFIX
#define MY_PREFIX Load_Multiple_Word

  /* extraction: 0.46,6.RT,11.RA,16.D #define get-values-from-icache */
#define RT cache_entry->crack.D.RT /* in icache - extraction */
#define rT cache_entry->crack.D.rT /* in icache - extraction */
#define RT_BITMASK cache_entry->crack.D.RT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24233 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2256 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Multiple Word\n"));
#line 24239 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_Multiple_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2256 "./ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int r;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    r = RT;
    if (RA >= r)
      program_interrupt(processor, cia,
                      illegal_instruction_program_interrupt);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT || (EA % 4 != 0))
      alignment_interrupt(processor, cia, EA);
    while (r <= 31) {
      GPR(r) = MEM(unsigned, EA, 4);
      r = r + 1;
      EA = EA + 4;
    }
  }
#line 24268 "semantics.c"
  return nia;
  /* extraction: 0.46,6.RT,11.RA,16.D #undef get-values-from-icache */
#undef RT
#undef rT
#undef RT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24279 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_Multiple_Word(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_Multiple_Word
#undef MY_PREFIX
#define MY_PREFIX Store_Multiple_Word

  /* extraction: 0.47,6.RS,11.RA,16.D #define get-values-from-icache */
#define RS cache_entry->crack.D.RS /* in icache - extraction */
#define rS cache_entry->crack.D.rS /* in icache - extraction */
#define RS_BITMASK cache_entry->crack.D.RS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24304 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 2275 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Multiple Word\n"));
#line 24310 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_Multiple_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 2275 "./ppc-instructions"
  {
    unsigned_word EA;
    unsigned_word b;
    int r;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    if (CURRENT_ALIGNMENT == STRICT_ALIGNMENT
        || (EA % 4 != 0))
      alignment_interrupt(processor, cia, EA);
    r = RS;
    while (r <= 31) {
      STORE(EA, 4, GPR(r));
      r = r + 1;
      EA = EA + 4;
    }
  }
#line 24337 "semantics.c"
  return nia;
  /* extraction: 0.47,6.RS,11.RA,16.D #undef get-values-from-icache */
#undef RS
#undef rS
#undef RS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24348 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single

  /* extraction: 0.48,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24372 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3466 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single\n"));
#line 24378 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3466 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24397 "semantics.c"
  return nia;
  /* extraction: 0.48,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24407 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Single_with_Update(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Single_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Single_with_Update

  /* extraction: 0.49,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24431 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3492 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Single with Update\n"));
#line 24437 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Single_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3492 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *frT = DOUBLE(MEM(unsigned, EA, 4));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24457 "semantics.c"
  return nia;
  /* extraction: 0.49,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24467 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double

  /* extraction: 0.50,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24491 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3520 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double\n"));
#line 24497 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3520 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    *frT = MEM(unsigned, EA, 8);
    PPC_INSN_INT_FLOAT(0, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24516 "semantics.c"
  return nia;
  /* extraction: 0.50,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24526 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Load_FloatingPoint_Double_with_Update(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Load_FloatingPoint_Double_with_Update
#undef MY_PREFIX
#define MY_PREFIX Load_FloatingPoint_Double_with_Update

  /* extraction: 0.51,6.FRT,11.RA,16.D #define get-values-from-icache */
#define frT cache_entry->crack.D.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.D.FRT_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24550 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3546 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Load Floating-Point Double with Update\n"));
#line 24556 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Load_FloatingPoint_Double_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3546 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    *frT = MEM(unsigned, EA, 8);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, FRT_BITMASK, (RA_BITMASK & ~1), 0);
  }
#line 24576 "semantics.c"
  return nia;
  /* extraction: 0.51,6.FRT,11.RA,16.D #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24586 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single

  /* extraction: 0.52,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24610 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3579 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single\n"));
#line 24616 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3579 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 4, SINGLE(*frS));
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24635 "semantics.c"
  return nia;
  /* extraction: 0.52,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24645 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Single_with_Update(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Single_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Single_with_Update

  /* extraction: 0.53,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24669 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3605 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Single with Update\n"));
#line 24675 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Single_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3605 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 4, SINGLE(*frS));
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24695 "semantics.c"
  return nia;
  /* extraction: 0.53,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24705 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double

  /* extraction: 0.54,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24729 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3633 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double\n"));
#line 24735 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3633 "./ppc-instructions"
  {
    unsigned_word b;
    unsigned_word EA;
    if (RA_is_0) b = 0;
    else         b = *rA;
    EA = b + EXTS(D);
    STORE(EA, 8, *frS);
    PPC_INSN_INT_FLOAT(0, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24754 "semantics.c"
  return nia;
  /* extraction: 0.54,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24764 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Store_FloatingPoint_Double_with_Update(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Store_FloatingPoint_Double_with_Update
#undef MY_PREFIX
#define MY_PREFIX Store_FloatingPoint_Double_with_Update

  /* extraction: 0.55,6.FRS,11.RA,16.D #define get-values-from-icache */
#define frS cache_entry->crack.D.frS /* in icache - extraction */
#define FRS_BITMASK cache_entry->crack.D.FRS_BITMASK /* in icache - extraction */
#define RA cache_entry->crack.D.RA /* in icache - extraction */
#define rA cache_entry->crack.D.rA /* in icache - extraction */
#define RA_BITMASK cache_entry->crack.D.RA_BITMASK /* in icache - extraction */
#define RA_is_0 (RA == 0) /* semantic compute - extraction */
#define EXTS_D cache_entry->crack.D.EXTS_D /* in icache - extraction */
#line 24788 "semantics.c"

#define insn cache_entry->crack.D.insn
  unsigned_word nia;
#line 3671 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Store Floating-Point Double with Update\n"));
#line 24794 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Store_FloatingPoint_Double_with_Update, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3671 "./ppc-instructions"
  {
    unsigned_word EA;
    if (RA_is_0)
      program_interrupt(processor, cia,
                        illegal_instruction_program_interrupt);
    EA = *rA + EXTS(D);
    STORE(EA, 8, *frS);
    *rA = EA;
    PPC_INSN_INT_FLOAT(RA_BITMASK, 0, (RA_BITMASK & ~1), FRS_BITMASK);
  }
#line 24814 "semantics.c"
  return nia;
  /* extraction: 0.55,6.FRS,11.RA,16.D #undef get-values-from-icache */
#undef frS
#undef FRS_BITMASK
#undef RA
#undef rA
#undef RA_BITMASK
#undef RA_is_0
#undef EXTS_D
#line 24824 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Single_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 24848 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3934 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide Single\n"));
#line 24854 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3934 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     1 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     1 /*single?*/);
    }
    else {
      /*HACK!*/
      float s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 24893 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 24903 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Single_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 24927 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3934 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide Single\n"));
#line 24933 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3934 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     1 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     1 /*single?*/);
    }
    else {
      /*HACK!*/
      float s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 24972 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 24982 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Single_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25006 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3823 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract Single\n"));
#line 25012 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3823 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25044 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25054 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Single_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25078 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3823 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract Single\n"));
#line 25084 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3823 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25116 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25126 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Single_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25150 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3771 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add Single\n"));
#line 25156 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3771 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25188 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25198 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Single_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25222 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3771 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add Single\n"));
#line 25228 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3771 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 25260 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25270 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Single_Rc0(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Single_Rc0

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25292 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4712 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root Single\n"));
#line 25298 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4712 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25311 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25319 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Single_Rc1(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Single_Rc1

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25341 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4712 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root Single\n"));
#line 25347 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4712 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25360 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25368 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Estimate_Single_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Estimate_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Estimate_Single_Rc0

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25390 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4715 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Estimate Single\n"));
#line 25396 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Estimate_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4715 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25409 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25417 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Estimate_Single_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Estimate_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Estimate_Single_Rc1

  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25439 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4715 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Estimate Single\n"));
#line 25445 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Estimate_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4715 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 25458 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11./,16.FRB,21./,26.24,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 25466 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_Single_Rc0(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25490 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3875 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply Single\n"));
#line 25496 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3875 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 25528 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25538 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_Single_Rc1(cpu *processor,
                                      idecode_cache *cache_entry,
                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25562 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3875 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply Single\n"));
#line 25568 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3875 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    1); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 25600 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25610 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_Single_Rc0(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25636 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4102 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract Single\n"));
#line 25642 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4102 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product - *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25693 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25705 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_Single_Rc1(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25731 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4102 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract Single\n"));
#line 25737 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4102 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product - *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25788 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25800 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_Single_Rc0(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 25826 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4012 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add Single\n"));
#line 25832 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4012 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product + *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25883 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25895 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_Single_Rc1(cpu *processor,
                                         idecode_cache *cache_entry,
                                         unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 25921 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4012 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add Single\n"));
#line 25927 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4012 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = product + *(double*)frB;
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 25978 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 25990 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_Single_Rc0(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26016 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4282 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract Single\n"));
#line 26022 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4282 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product - *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26073 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26085 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_Single_Rc1(cpu *processor,
                                                       idecode_cache *cache_entry,
                                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 26111 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4282 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract Single\n"));
#line 26117 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4282 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product - *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26168 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26180 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_Single_Rc0(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_Single_Rc0

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26206 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4192 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add Single\n"));
#line 26212 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4192 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product + *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26263 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26275 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_Single_Rc1(cpu *processor,
                                                  idecode_cache *cache_entry,
                                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd_Single
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_Single_Rc1

  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 26301 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4192 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add Single\n"));
#line 26307 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd_Single, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4192 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    float product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             1, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      float s = -(product + *(double*)frB);
      *(double*)frT = (double)s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 26358 "semantics.c"
  return nia;
  /* extraction: 0.59,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 26370 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Compare_Unordered(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Compare_Unordered
#undef MY_PREFIX
#define MY_PREFIX Floating_Compare_Unordered

  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.X.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.X.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#line 26393 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4607 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Compare Unordered\n"));
#line 26399 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Compare_Unordered, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4607 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned c;
    if (is_NaN(*frA, 0) || is_NaN(*frB, 0))
      c = cr_i_summary_overflow; /* 0b0001 - (FRA) ? (FRB) */
    else if (is_less_than(frA, frB))
      c = cr_i_negative; /* 0b1000 - (FRA) < (FRB) */
    else if (is_greater_than(frA, frB))
      c = cr_i_positive; /* 0b0100 - (FRA) > (FRB) */
    else
      c = cr_i_zero; /* 0b0010 - (FRA) = (FRB) */
    FPSCR_SET_FPCC(c);
    CR_SET(BF, c); /* CR[4*BF..4*BF+3] = c */
    if (is_SNaN(*frA, 0) || is_SNaN(*frB, 0))
      FPSCR_OR_VX(fpscr_vxsnan);
    FPSCR_END(0);
    PPC_INSN_FLOAT_CR(0, FRA_BITMASK | FRB_BITMASK, BF_BITMASK);
  }
#line 26427 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.0,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#line 26436 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Round_to_SinglePrecision_Rc0(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Round_to_SinglePrecision
#undef MY_PREFIX
#define MY_PREFIX Floating_Round_to_SinglePrecision_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26458 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4332 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Round to Single-Precision\n"));
#line 26464 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Round_to_SinglePrecision, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4332 "./ppc-instructions"
  {
    int sign;
    int exp;
    unsigned64 frac_grx;
    /***/
      /* split off cases for what to do */
      if (EXTRACTED64(*frB, 1, 11) < 897
          && EXTRACTED64(*frB, 1, 63) > 0) {
          if ((FPSCR & fpscr_ue) == 0) GOTO(Disabled_Exponent_Underflow);
          if ((FPSCR & fpscr_ue) != 0) GOTO(Enabled_Exponent_Underflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 1150
          && EXTRACTED64(*frB, 1, 11) < 2047) {
          if ((FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
          if ((FPSCR & fpscr_oe) != 0) GOTO(Enabled_Exponent_Overflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 896
          && EXTRACTED64(*frB, 1, 11) < 1151) GOTO(Normal_Operand);
      if (EXTRACTED64(*frB, 1, 63) == 0) GOTO(Zero_Operand);
      if (EXTRACTED64(*frB, 1, 11) == 2047) {
        if (EXTRACTED64(*frB, 12, 63) == 0) GOTO(Infinity_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 1) GOTO(QNaN_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 0
            && EXTRACTED64(*frB, 13, 63) > 0) GOTO(SNaN_Operand);
      }
    /**/
    LABEL(Disabled_Exponent_Underflow):
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
        /* G|R|X == zero from above */
        while (exp < -126) {
          exp = exp + 1;
          frac_grx = (INSERTED64(EXTRACTED64(frac_grx, 0, 54), 1, 55)
                      | MASKED64(frac_grx, 55, 55));
        }
      FPSCR_SET_UX(EXTRACTED64(frac_grx, 24, 55) > 0);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (EXTRACTED64(frac_grx, 0, 52) == 0) {
        *frT = INSERTED64(sign, 0, 0);
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      }
      if (EXTRACTED64(frac_grx, 0, 52) > 0) {
        if (EXTRACTED64(frac_grx, 0, 0) == 1) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
        if (EXTRACTED64(frac_grx, 0, 0) == 0) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_denormalized_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_denormalized_number);
        }
        /*Normalize_Operand:*/
          while (EXTRACTED64(frac_grx, 0, 0) == 0) {
            exp = exp - 1;
            frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1,  52), 0, 51);
          }
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      }
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Underflow):
      FPSCR_SET_UX(1);
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = (BIT64(0) |
                    INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52));
      }
      /*Normalize_Operand:*/
        while (EXTRACTED64(frac_grx, 0, 0) == 0) {
          exp = exp - 1;
          frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1, 52), 0, 51);
        }
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      exp = exp + 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Disabled_Exponent_Overflow):
      FPSCR_SET_OX(1);
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_to_nearest) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_zero) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_pos_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_neg_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      /* FPSCR[FR] <- undefined */
      FPSCR_SET_FI(1);
      FPSCR_SET_XX(1);
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Overflow):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
    /**/
    LABEL(Enabled_Overflow):
      FPSCR_SET_OX(1);
      exp = exp - 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Zero_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Infinity_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(QNaN_Operand):
      *frT = INSERTED64(EXTRACTED64(*frB, 0, 34), 0, 34);
      FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(SNaN_Operand):
      FPSCR_OR_VX(fpscr_vxsnan);
      if ((FPSCR & fpscr_ve) == 0) {
        *frT = (MASKED64(*frB, 0, 11)
                | BIT64(12)
                | MASKED64(*frB, 13, 34));
        FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      }
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Normal_Operand):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (exp > 127 && (FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
      if (exp > 127 && (FPSCR & fpscr_oe) != 0) GOTO(Enabled_Overflow);
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Done):
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 26688 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 26696 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Round_to_SinglePrecision_Rc1(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Round_to_SinglePrecision
#undef MY_PREFIX
#define MY_PREFIX Floating_Round_to_SinglePrecision_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 26718 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4332 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Round to Single-Precision\n"));
#line 26724 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Round_to_SinglePrecision, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4332 "./ppc-instructions"
  {
    int sign;
    int exp;
    unsigned64 frac_grx;
    /***/
      /* split off cases for what to do */
      if (EXTRACTED64(*frB, 1, 11) < 897
          && EXTRACTED64(*frB, 1, 63) > 0) {
          if ((FPSCR & fpscr_ue) == 0) GOTO(Disabled_Exponent_Underflow);
          if ((FPSCR & fpscr_ue) != 0) GOTO(Enabled_Exponent_Underflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 1150
          && EXTRACTED64(*frB, 1, 11) < 2047) {
          if ((FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
          if ((FPSCR & fpscr_oe) != 0) GOTO(Enabled_Exponent_Overflow);
      }
      if (EXTRACTED64(*frB, 1, 11) > 896
          && EXTRACTED64(*frB, 1, 11) < 1151) GOTO(Normal_Operand);
      if (EXTRACTED64(*frB, 1, 63) == 0) GOTO(Zero_Operand);
      if (EXTRACTED64(*frB, 1, 11) == 2047) {
        if (EXTRACTED64(*frB, 12, 63) == 0) GOTO(Infinity_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 1) GOTO(QNaN_Operand);
        if (EXTRACTED64(*frB, 12, 12) == 0
            && EXTRACTED64(*frB, 13, 63) > 0) GOTO(SNaN_Operand);
      }
    /**/
    LABEL(Disabled_Exponent_Underflow):
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
        /* G|R|X == zero from above */
        while (exp < -126) {
          exp = exp + 1;
          frac_grx = (INSERTED64(EXTRACTED64(frac_grx, 0, 54), 1, 55)
                      | MASKED64(frac_grx, 55, 55));
        }
      FPSCR_SET_UX(EXTRACTED64(frac_grx, 24, 55) > 0);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (EXTRACTED64(frac_grx, 0, 52) == 0) {
        *frT = INSERTED64(sign, 0, 0);
        if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
        if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      }
      if (EXTRACTED64(frac_grx, 0, 52) > 0) {
        if (EXTRACTED64(frac_grx, 0, 0) == 1) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
        if (EXTRACTED64(frac_grx, 0, 0) == 0) {
          if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_denormalized_number);
          if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_denormalized_number);
        }
        /*Normalize_Operand:*/
          while (EXTRACTED64(frac_grx, 0, 0) == 0) {
            exp = exp - 1;
            frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1,  52), 0, 51);
          }
        *frT = (INSERTED64(sign, 0, 0)
                | INSERTED64(exp + 1023, 1, 11)
                | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      }
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Underflow):
      FPSCR_SET_UX(1);
      sign = EXTRACTED64(*frB, 0, 0);
      if (EXTRACTED64(*frB, 1, 11) == 0) {
        exp = -1022;
        frac_grx = INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      }
      if (EXTRACTED64(*frB, 1, 11) > 0) {
        exp = EXTRACTED64(*frB, 1, 11) - 1023;
        frac_grx = (BIT64(0) |
                    INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52));
      }
      /*Normalize_Operand:*/
        while (EXTRACTED64(frac_grx, 0, 0) == 0) {
          exp = exp - 1;
          frac_grx = INSERTED64(EXTRACTED64(frac_grx, 1, 52), 0, 51);
        }
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      exp = exp + 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Disabled_Exponent_Overflow):
      FPSCR_SET_OX(1);
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_to_nearest) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_zero) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_pos_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x7FF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xC7EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
        }
      }
      if ((FPSCR & fpscr_rn) == fpscr_rn_round_towards_neg_infinity) {
        if (EXTRACTED64(*frB, 0, 0) == 0) {
          *frT = INSERTED64(0x47EFFFFF, 0, 31) | 0xE0000000;
          FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
        }
        if (EXTRACTED64(*frB, 0, 0) == 1) {
          *frT = INSERTED64(0xFFF00000, 0, 31) | 0x00000000;
          FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
        }
      }
      /* FPSCR[FR] <- undefined */
      FPSCR_SET_FI(1);
      FPSCR_SET_XX(1);
      GOTO(Done);
    /**/
    LABEL(Enabled_Exponent_Overflow):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
    /**/
    LABEL(Enabled_Overflow):
      FPSCR_SET_OX(1);
      exp = exp - 192;
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Zero_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_zero);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_zero);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Infinity_Operand):
      *frT = *frB;
      if (EXTRACTED64(*frB, 0, 0) == 0) FPSCR_SET_FPRF(fpscr_rf_pos_infinity);
      if (EXTRACTED64(*frB, 0, 0) == 1) FPSCR_SET_FPRF(fpscr_rf_neg_infinity);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(QNaN_Operand):
      *frT = INSERTED64(EXTRACTED64(*frB, 0, 34), 0, 34);
      FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(SNaN_Operand):
      FPSCR_OR_VX(fpscr_vxsnan);
      if ((FPSCR & fpscr_ve) == 0) {
        *frT = (MASKED64(*frB, 0, 11)
                | BIT64(12)
                | MASKED64(*frB, 13, 34));
        FPSCR_SET_FPRF(fpscr_rf_quiet_nan);
      }
      FPSCR_SET_FR(0);
      FPSCR_SET_FI(0);
      GOTO(Done);
    /**/
    LABEL(Normal_Operand):
      sign = EXTRACTED64(*frB, 0, 0);
      exp = EXTRACTED64(*frB, 1, 11) - 1023;
      frac_grx = BIT64(0) | INSERTED64(EXTRACTED64(*frB, 12, 63), 1, 52);
      Round_Single(processor, sign, &exp, &frac_grx);
      FPSCR_SET_XX(FPSCR & fpscr_fi);
      if (exp > 127 && (FPSCR & fpscr_oe) == 0) GOTO(Disabled_Exponent_Overflow);
      if (exp > 127 && (FPSCR & fpscr_oe) != 0) GOTO(Enabled_Overflow);
      *frT = (INSERTED64(sign, 0, 0)
              | INSERTED64(exp + 1023, 1, 11)
              | INSERTED64(EXTRACTED64(frac_grx, 1, 52), 12, 63));
      if (sign == 0) FPSCR_SET_FPRF(fpscr_rf_pos_normal_number);
      if (sign == 1) FPSCR_SET_FPRF(fpscr_rf_neg_normal_number);
      GOTO(Done);
    /**/
    LABEL(Done):
      PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 26948 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.12,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 26956 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_Rc0(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 26978 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4553 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word\n"));
#line 26984 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4553 "./ppc-instructions"
  {
    floating_point_assist_interrupt(processor, cia);
  }
#line 26997 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27005 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_Rc1(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27027 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4553 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word\n"));
#line 27033 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4553 "./ppc-instructions"
  {
    floating_point_assist_interrupt(processor, cia);
  }
#line 27046 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.14,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27054 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0(cpu *processor,
                                                                      idecode_cache *cache_entry,
                                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27076 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4560 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word with round towards Zero\n"));
#line 27082 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4560 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    convert_to_integer(processor, cia,
                       frT, *frB,
                       fpscr_rn_round_towards_zero, 32);
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 27100 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27108 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1(cpu *processor,
                                                                      idecode_cache *cache_entry,
                                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero
#undef MY_PREFIX
#define MY_PREFIX Floating_Convert_To_Integer_Word_with_round_towards_Zero_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27130 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4560 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Convert To Integer Word with round towards Zero\n"));
#line 27136 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Convert_To_Integer_Word_with_round_towards_Zero, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4560 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    convert_to_integer(processor, cia,
                       frT, *frB,
                       fpscr_rn_round_towards_zero, 32);
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 27154 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.15,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27162 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27186 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3901 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide\n"));
#line 27192 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3901 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     0 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     0 /*single?*/);
    }
    else {
      /*HACK!*/
      double s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27231 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27241 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Divide_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Divide
#undef MY_PREFIX
#define MY_PREFIX Floating_Divide_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27265 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3901 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Divide\n"));
#line 27271 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Divide, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3901 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxzdz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else if (is_invalid_zero_divide (processor, cia,
                                     *frA, *frB,
                                     0 /*single?*/)) {
      invalid_zero_divide_operation (processor, cia,
                                     frT, *frA, *frB,
                                     0 /*single?*/);
    }
    else {
      /*HACK!*/
      double s = *(double*)frA / *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27310 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.18,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27320 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Rc0(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27344 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3797 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract\n"));
#line 27350 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3797 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27382 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27392 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Subtract_Rc1(cpu *processor,
                               idecode_cache *cache_entry,
                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Subtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Subtract_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27416 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3797 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Subtract\n"));
#line 27422 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Subtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3797 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             1) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27454 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.20,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27464 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Rc0(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27488 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3745 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add\n"));
#line 27494 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3745 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27526 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27536 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Add_Rc1(cpu *processor,
                          idecode_cache *cache_entry,
                          unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Add
#undef MY_PREFIX
#define MY_PREFIX Floating_Add_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27560 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3745 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Add\n"));
#line 27566 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Add, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3745 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK, Rc);
  }
#line 27598 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21./,26.21,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27608 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27630 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4709 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root\n"));
#line 27636 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4709 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 27649 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27657 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Square_Root_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Square_Root
#undef MY_PREFIX
#define MY_PREFIX Floating_Square_Root_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27679 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4709 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Square Root\n"));
#line 27685 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Square_Root, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4709 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 27698 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.22,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 27706 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC0_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27732 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 27738 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 27760 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27772 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC0_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27798 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 27804 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 27826 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27838 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC0_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 27862 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 27868 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 27900 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27910 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC0_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 27934 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 27940 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 27972 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 27982 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Square_Root_Estimate_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Square_Root_Estimate
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Square_Root_Estimate_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28004 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4718 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Square Root Estimate\n"));
#line 28010 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Square_Root_Estimate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4718 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 28023 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 28031 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Reciprocal_Square_Root_Estimate_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Reciprocal_Square_Root_Estimate
#undef MY_PREFIX
#define MY_PREFIX Floating_Reciprocal_Square_Root_Estimate_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28053 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4718 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Reciprocal Square Root Estimate\n"));
#line 28059 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Reciprocal_Square_Root_Estimate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4718 "./ppc-instructions"
  {
    program_interrupt(processor, cia, optional_instruction_program_interrupt);
  }
#line 28072 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21./,26.26,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 28080 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC0_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28106 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 28112 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28163 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28175 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC0_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28201 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 28207 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28258 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28270 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC0_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28296 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 28302 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28353 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28365 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC0_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28391 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 28397 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28448 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28460 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC0_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28486 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 28492 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28543 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28555 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC0_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28581 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 28587 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28638 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28650 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC0_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC0_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28676 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 28682 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28733 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC0_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC0_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28771 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 28777 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 28828 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 28840 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Compare_Ordered(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Compare_Ordered
#undef MY_PREFIX
#define MY_PREFIX Floating_Compare_Ordered

  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.X.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.X.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#line 28863 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4629 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Compare Ordered\n"));
#line 28869 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Compare_Ordered, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4629 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned c;
    if (is_NaN(*frA, 0) || is_NaN(*frB, 0))
      c = cr_i_summary_overflow; /* 0b0001 - (FRA) ? (FRB) */
    else if (is_less_than(frA, frB))
      c = cr_i_negative; /* 0b1000 - (FRA) < (FRB) */
    else if (is_greater_than(frA, frB))
      c = cr_i_positive; /* 0b0100 - (FRA) > (FRB) */
    else
      c = cr_i_zero; /* 0b0010 - (FRA) = (FRB) */
    FPSCR_SET_FPCC(c);
    CR_SET(BF, c); /* CR[4*BF..4*BF+3] = c */
    if (is_SNaN(*frA, 0) || is_SNaN(*frB, 0)) {
      FPSCR_OR_VX(fpscr_vxsnan);
      if ((FPSCR & fpscr_ve) == 0)
        FPSCR_OR_VX(fpscr_vxvc);
    }
    else if (is_QNaN(*frA, 0) || is_QNaN(*frB, 0)) {
      FPSCR_OR_VX(fpscr_vxvc);
    }
    FPSCR_END(0);
    PPC_INSN_FLOAT_CR(0, FRA_BITMASK | FRB_BITMASK, BF_BITMASK);
  }
#line 28903 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11.FRA,16.FRB,21.32,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#line 28912 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_1_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_1
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_1_Rc0

  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 28932 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4692 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 1\n"));
#line 28938 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_1, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4692 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    if (bit & fpscr_fi)
      bit |= fpscr_xx;
    if ((bit & fpscr_vx_bits))
      bit |= fpscr_fx;
    /* note - omit vx bit */
    if ((bit & (fpscr_ox | fpscr_ux | fpscr_zx | fpscr_xx)))
      bit |= fpscr_fx;
    FPSCR |= bit;
    FPSCR_END(Rc);
  }
#line 28961 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 28967 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_1_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_1
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_1_Rc1

  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 28987 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4692 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 1\n"));
#line 28993 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_1, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4692 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    if (bit & fpscr_fi)
      bit |= fpscr_xx;
    if ((bit & fpscr_vx_bits))
      bit |= fpscr_fx;
    /* note - omit vx bit */
    if ((bit & (fpscr_ox | fpscr_ux | fpscr_zx | fpscr_xx)))
      bit |= fpscr_fx;
    FPSCR |= bit;
    FPSCR_END(Rc);
  }
#line 29016 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.38,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 29022 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negate_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negate
#undef MY_PREFIX
#define MY_PREFIX Floating_Negate_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29044 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3713 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negate\n"));
#line 29050 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3713 "./ppc-instructions"
  {
    *frT = *frB ^ BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 29065 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 29073 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negate_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negate
#undef MY_PREFIX
#define MY_PREFIX Floating_Negate_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29095 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3713 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negate\n"));
#line 29101 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3713 "./ppc-instructions"
  {
    *frT = *frB ^ BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 29116 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.40,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 29124 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC1_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29150 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 29156 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 29178 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29190 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC1_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29216 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 29222 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 29244 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29256 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC1_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29280 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 29286 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 29318 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29328 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC1_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29352 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 29358 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 29390 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29400 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC1_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29426 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 29432 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29483 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29495 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC1_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29521 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 29527 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29578 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29590 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC1_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29616 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 29622 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29673 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29685 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC1_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29711 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 29717 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29768 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29780 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC1_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29806 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 29812 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29863 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29875 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC1_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 29901 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 29907 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 29958 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 29970 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC1_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC1_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 29996 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 30002 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30053 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30065 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC1_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC1_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30091 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 30097 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30148 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30160 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_to_Condition_Register_from_FPSCR(cpu *processor,
                                               idecode_cache *cache_entry,
                                               unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_to_Condition_Register_from_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_to_Condition_Register_from_FPSCR

  /* extraction: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define BFA cache_entry->crack.X.BFA /* default in icache - extraction */
#line 30180 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4663 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move to Condition Register from FPSCR\n"));
#line 30186 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_to_Condition_Register_from_FPSCR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4663 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned field = FPSCR_FIELD(BFA);
    CR_SET(BF, field);
    FPSCR_SET(BFA, 0); /* FPSCR_END fixes up FEX/VX */
    FPSCR_END(0);
  }
#line 30203 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11.BFA,14./,16./,21.64,31./ #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef BFA
#line 30209 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_0_Rc0(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_0
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_0_Rc0

  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30229 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4686 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 0\n"));
#line 30235 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_0, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4686 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    FPSCR &= ~bit;
    FPSCR_END(Rc);
  }
#line 30251 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 30257 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Bit_0_Rc1(cpu *processor,
                                 idecode_cache *cache_entry,
                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Bit_0
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Bit_0_Rc1

  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #define get-values-from-icache */
#define BT cache_entry->crack.X.BT /* in icache - extraction */
#define BT_BITMASK cache_entry->crack.X.BT_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30277 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4686 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Bit 0\n"));
#line 30283 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Bit_0, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4686 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    unsigned32 bit = BIT32(BT);
    FPSCR &= ~bit;
    FPSCR_END(Rc);
  }
#line 30299 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BT,11./,16./,21.70,31.Rc #undef get-values-from-icache */
#undef BT
#undef BT_BITMASK
#undef Rc
#line 30305 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Move_Register_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Move_Register
#undef MY_PREFIX
#define MY_PREFIX Floating_Move_Register_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30327 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3704 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Move Register\n"));
#line 30333 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Move_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3704 "./ppc-instructions"
  {
    *frT = *frB;
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 30348 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 30356 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Move_Register_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Move_Register
#undef MY_PREFIX
#define MY_PREFIX Floating_Move_Register_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30378 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3704 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Move Register\n"));
#line 30384 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Move_Register, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3704 "./ppc-instructions"
  {
    *frT = *frB;
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 30399 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.72,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 30407 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC2_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30433 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 30439 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 30461 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30473 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC2_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30499 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 30505 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 30527 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30539 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC2_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30563 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 30569 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 30601 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30611 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC2_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30635 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 30641 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 30673 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30683 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC2_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30709 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 30715 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30766 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30778 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC2_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30804 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 30810 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30861 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30873 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC2_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 30899 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 30905 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 30956 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 30968 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC2_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 30994 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 31000 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31051 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31063 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC2_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31089 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 31095 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31146 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31158 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC2_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31184 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 31190 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31241 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31253 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC2_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC2_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31279 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 31285 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31336 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31348 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC2_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC2_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31374 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 31380 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31431 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31443 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC3_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31469 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 31475 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 31497 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31509 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC3_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31535 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 31541 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 31563 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31575 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC3_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31599 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 31605 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 31637 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31647 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC3_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31671 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 31677 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 31709 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31719 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC3_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31745 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 31751 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31802 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31814 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC3_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 31840 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 31846 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31897 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 31909 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC3_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 31935 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 31941 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 31992 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32004 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC3_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32030 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 32036 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32087 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32099 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC3_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32125 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 32131 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32182 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32194 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC3_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32220 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 32226 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32277 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32289 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC3_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC3_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32315 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 32321 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32372 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32384 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC3_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC3_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32410 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 32416 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 32467 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32479 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Field_Immediate_Rc0(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Field_Immediate
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Field_Immediate_Rc0

  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define U cache_entry->crack.X.U /* default in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32500 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4670 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Field Immediate\n"));
#line 32506 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Field_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4670 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    FPSCR_SET(BF, U);
    FPSCR_END(Rc);
  }
#line 32521 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef U
#undef Rc
#line 32528 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Field_Immediate_Rc1(cpu *processor,
                                           idecode_cache *cache_entry,
                                           unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Field_Immediate
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Field_Immediate_Rc1

  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #define get-values-from-icache */
#define BF cache_entry->crack.X.BF /* in icache - extraction */
#define BF_BITMASK cache_entry->crack.X.BF_BITMASK /* in icache - extraction */
#define U cache_entry->crack.X.U /* default in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32549 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4670 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Field Immediate\n"));
#line 32555 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Field_Immediate, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4670 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    FPSCR_SET(BF, U);
    FPSCR_END(Rc);
  }
#line 32570 "semantics.c"
  return nia;
  /* extraction: 0.63,6.BF,9./,11./,16.U,20./,21.134,31.Rc #undef get-values-from-icache */
#undef BF
#undef BF_BITMASK
#undef U
#undef Rc
#line 32577 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_Absolute_Value_Rc0(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_Absolute_Value_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32599 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3731 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Absolute Value\n"));
#line 32605 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3731 "./ppc-instructions"
  {
    *frT = *frB | BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 32620 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 32628 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_Absolute_Value_Rc1(cpu *processor,
                                              idecode_cache *cache_entry,
                                              unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_Absolute_Value_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32650 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3731 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Absolute Value\n"));
#line 32656 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3731 "./ppc-instructions"
  {
    *frT = *frB | BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 32671 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.136,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 32679 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC4_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32705 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 32711 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 32733 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32745 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC4_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32771 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 32777 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 32799 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32811 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC4_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32835 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 32841 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 32873 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32883 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC4_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 32907 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 32913 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 32945 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 32955 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC4_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 32981 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 32987 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33038 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33050 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC4_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33076 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 33082 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33133 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33145 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC4_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33171 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 33177 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33228 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33240 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC4_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33266 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 33272 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33323 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33335 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC4_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33361 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 33367 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33418 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33430 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC4_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33456 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 33462 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33513 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33525 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC4_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC4_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33551 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 33557 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33608 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33620 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC4_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC4_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33646 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 33652 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 33703 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33715 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC5_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33741 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 33747 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 33769 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33781 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC5_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33807 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 33813 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 33835 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33847 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC5_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 33871 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 33877 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 33909 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33919 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC5_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 33943 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 33949 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 33981 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 33991 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC5_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34017 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 34023 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34074 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34086 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC5_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34112 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 34118 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34169 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34181 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC5_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34207 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 34213 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34264 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34276 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC5_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34302 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 34308 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34359 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34371 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC5_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34397 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 34403 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34454 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34466 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC5_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34492 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 34498 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34549 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34561 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC5_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC5_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34587 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 34593 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34644 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34656 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC5_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC5_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34682 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 34688 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 34739 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34751 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC6_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34777 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 34783 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 34805 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34817 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC6_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34843 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 34849 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 34871 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34883 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC6_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 34907 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 34913 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 34945 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 34955 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC6_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 34979 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 34985 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 35017 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35027 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC6_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35053 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 35059 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35110 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35122 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC6_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35148 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 35154 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35205 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35217 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC6_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35243 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 35249 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35300 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35312 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC6_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35338 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 35344 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35395 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35407 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC6_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35433 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 35439 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35490 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35502 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC6_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35528 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 35534 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35585 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35597 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC6_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC6_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35623 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 35629 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35680 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35692 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC6_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC6_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35718 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 35724 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 35775 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35787 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC7_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35813 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 35819 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 35841 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35853 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC7_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 35879 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 35885 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 35907 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35919 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC7_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 35943 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 35949 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 35981 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 35991 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC7_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36015 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 36021 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 36053 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36063 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC7_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36089 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 36095 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36146 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36158 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC7_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36184 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 36190 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36241 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36253 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC7_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36279 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 36285 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36336 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36348 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC7_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36374 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 36380 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36431 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36443 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC7_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36469 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 36475 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36526 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36538 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC7_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36564 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 36570 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36621 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36633 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC7_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC7_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36659 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 36665 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36716 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36728 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC7_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC7_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36754 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 36760 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 36811 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36823 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Absolute_Value_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Absolute_Value_Rc0

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36845 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3722 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Absolute Value\n"));
#line 36851 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3722 "./ppc-instructions"
  {
    *frT = *frB & ~BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 36866 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 36874 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Absolute_Value_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Absolute_Value
#undef MY_PREFIX
#define MY_PREFIX Floating_Absolute_Value_Rc1

  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.X.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.X.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 36896 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 3722 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Absolute Value\n"));
#line 36902 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Absolute_Value, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3722 "./ppc-instructions"
  {
    *frT = *frB & ~BIT64(0);
    CR1_UPDATE(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRB_BITMASK, Rc);
  }
#line 36917 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16.FRB,21.264,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 36925 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC8_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 36951 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 36957 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 36979 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 36991 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC8_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37017 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 37023 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 37045 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37057 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC8_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37081 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 37087 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 37119 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37129 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC8_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37153 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 37159 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 37191 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37201 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC8_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37227 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 37233 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37284 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37296 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC8_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37322 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 37328 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37379 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37391 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC8_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37417 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 37423 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37474 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37486 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC8_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37512 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 37518 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37569 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37581 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC8_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37607 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 37613 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37664 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37676 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC8_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37702 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 37708 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37759 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37771 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC8_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC8_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37797 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 37803 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37854 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37866 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC8_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC8_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 37892 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 37898 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 37949 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 37961 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC9_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 37987 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 37993 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 38015 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38027 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC9_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38053 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 38059 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 38081 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38093 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC9_Rc0(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38117 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 38123 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 38155 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38165 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC9_Rc1(cpu *processor,
                                    idecode_cache *cache_entry,
                                    unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38189 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 38195 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 38227 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38237 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC9_Rc0(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38263 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 38269 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38320 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38332 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC9_Rc1(cpu *processor,
                                            idecode_cache *cache_entry,
                                            unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38358 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 38364 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38415 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38427 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC9_Rc0(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38453 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 38459 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38510 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38522 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC9_Rc1(cpu *processor,
                                       idecode_cache *cache_entry,
                                       unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38548 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 38554 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38605 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38617 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC9_Rc0(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38643 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 38649 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38700 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38712 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC9_Rc1(cpu *processor,
                                                     idecode_cache *cache_entry,
                                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38738 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 38744 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38795 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38807 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC9_Rc0(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC9_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 38833 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 38839 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38890 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38902 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC9_Rc1(cpu *processor,
                                                idecode_cache *cache_entry,
                                                unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC9_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 38928 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 38934 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 38985 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 38997 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC10_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39023 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 39029 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 39051 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39063 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC10_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39089 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 39095 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 39117 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39129 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC10_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39153 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 39159 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 39191 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39201 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC10_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39225 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 39231 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 39263 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39273 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC10_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39299 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 39305 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39356 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39368 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC10_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39394 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 39400 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39451 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39463 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC10_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39489 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 39495 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39546 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39558 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC10_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39584 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 39590 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39641 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39653 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC10_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39679 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 39685 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39736 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39748 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC10_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39774 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 39780 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39831 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39843 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC10_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC10_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 39869 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 39875 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 39926 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 39938 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC10_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC10_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 39964 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 39970 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40021 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40033 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC11_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40059 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 40065 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 40087 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40099 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC11_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40125 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 40131 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 40153 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40165 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC11_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40189 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 40195 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 40227 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40237 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC11_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40261 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 40267 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 40299 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40309 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC11_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40335 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 40341 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40392 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40404 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC11_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40430 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 40436 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40487 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40499 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC11_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40525 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 40531 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40582 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40594 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC11_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40620 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 40626 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40677 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40689 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC11_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40715 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 40721 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40772 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40784 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC11_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 40810 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 40816 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40867 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40879 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC11_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC11_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 40905 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 40911 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 40962 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 40974 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC11_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC11_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41000 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 41006 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41057 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41069 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC12_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41095 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 41101 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 41123 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41135 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC12_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41161 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 41167 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 41189 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41201 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC12_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41225 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 41231 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 41263 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41273 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC12_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41297 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 41303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 41335 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41345 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC12_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41371 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 41377 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41428 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41440 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC12_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41466 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 41472 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41523 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41535 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC12_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41561 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 41567 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41618 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41630 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC12_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41656 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 41662 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41713 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41725 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC12_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41751 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 41757 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41808 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41820 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC12_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 41846 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 41852 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41903 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 41915 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC12_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC12_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 41941 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 41947 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 41998 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42010 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC12_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC12_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42036 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 42042 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42093 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42105 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC13_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42131 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 42137 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 42159 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42171 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC13_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42197 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 42203 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 42225 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42237 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC13_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42261 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 42267 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 42299 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42309 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC13_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42333 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 42339 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 42371 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42381 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC13_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42407 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 42413 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42464 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42476 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC13_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42502 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 42508 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42559 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42571 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC13_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42597 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 42603 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42654 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42666 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC13_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42692 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 42698 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42749 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42761 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC13_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42787 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 42793 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42844 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42856 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC13_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 42882 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 42888 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 42939 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 42951 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC13_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC13_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 42977 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 42983 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43034 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43046 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC13_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC13_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43072 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 43078 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43129 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43141 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC14_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43167 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 43173 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 43195 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43207 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC14_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43233 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 43239 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 43261 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43273 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC14_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43297 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 43303 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 43335 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43345 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC14_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43369 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 43375 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 43407 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43417 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC14_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43443 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 43449 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43500 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43512 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC14_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43538 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 43544 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43595 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43607 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC14_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43633 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 43639 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43690 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43702 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC14_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43728 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 43734 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43785 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43797 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC14_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 43823 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 43829 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43880 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43892 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC14_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 43918 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 43924 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 43975 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 43987 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC14_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC14_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44013 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 44019 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44070 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44082 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC14_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC14_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44108 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 44114 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44165 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44177 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC15_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44203 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 44209 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 44231 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44243 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC15_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44269 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 44275 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 44297 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44309 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC15_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44333 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 44339 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 44371 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44381 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC15_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44405 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 44411 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 44443 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44453 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC15_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44479 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 44485 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44536 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44548 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC15_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44574 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 44580 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44631 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44643 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC15_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44669 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 44675 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44726 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44738 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC15_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44764 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 44770 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44821 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44833 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC15_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 44859 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 44865 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 44916 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 44928 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC15_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 44954 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 44960 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45011 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45023 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC15_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC15_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45049 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 45055 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45106 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45118 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC15_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC15_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45144 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 45150 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45201 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45213 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC16_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45239 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 45245 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 45267 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45279 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC16_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45305 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 45311 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 45333 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45345 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC16_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45369 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 45375 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 45407 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45417 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC16_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45441 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 45447 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 45479 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45489 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC16_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45515 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 45521 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45572 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45584 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC16_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45610 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 45616 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45667 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45679 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC16_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45705 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 45711 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45762 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45774 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC16_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45800 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 45806 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45857 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45869 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC16_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 45895 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 45901 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 45952 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 45964 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC16_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 45990 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 45996 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46047 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46059 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC16_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC16_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46085 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 46091 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46142 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46154 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC16_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC16_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46180 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 46186 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46237 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46249 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC17_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46275 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 46281 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 46303 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46315 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC17_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46341 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 46347 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 46369 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46381 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC17_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46405 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 46411 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 46443 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46453 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC17_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46477 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 46483 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 46515 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46525 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC17_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46551 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 46557 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46608 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46620 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC17_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46646 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 46652 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46703 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46715 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC17_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46741 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 46747 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46798 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46810 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC17_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 46836 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 46842 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46893 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 46905 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC17_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 46931 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 46937 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 46988 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47000 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC17_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47026 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 47032 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47083 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47095 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC17_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC17_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47121 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 47127 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47178 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47190 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC17_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC17_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47216 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 47222 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47273 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47285 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_FPSCR_Rc0(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_From_FPSCR_Rc0

  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47305 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4658 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From FPSCR\n"));
#line 47311 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_FPSCR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4658 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    *frT = FPSCR;
    FPSCR_END(Rc);
  }
#line 47326 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef Rc
#line 47332 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_From_FPSCR_Rc1(cpu *processor,
                             idecode_cache *cache_entry,
                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_From_FPSCR
#undef MY_PREFIX
#define MY_PREFIX Move_From_FPSCR_Rc1

  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.X.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.X.FRT_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47352 "semantics.c"

#define insn cache_entry->crack.X.insn
  unsigned_word nia;
#line 4658 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move From FPSCR\n"));
#line 47358 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_From_FPSCR, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4658 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    *frT = FPSCR;
    FPSCR_END(Rc);
  }
#line 47373 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11./,16./,21.583,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef Rc
#line 47379 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC18_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47405 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 47411 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 47433 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47445 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC18_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47471 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 47477 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 47499 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47511 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC18_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47535 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 47541 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 47573 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47583 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC18_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47607 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 47613 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 47645 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47655 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC18_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47681 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 47687 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47738 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47750 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC18_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47776 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 47782 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47833 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47845 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC18_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 47871 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 47877 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 47928 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 47940 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC18_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 47966 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 47972 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48023 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48035 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC18_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48061 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 48067 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48118 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48130 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC18_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48156 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 48162 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48213 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48225 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC18_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC18_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48251 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 48257 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48308 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48320 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC18_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC18_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48346 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 48352 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48403 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48415 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC19_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48441 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 48447 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 48469 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48481 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC19_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48507 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 48513 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 48535 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48547 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC19_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48571 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 48577 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 48609 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48619 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC19_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48643 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 48649 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 48681 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48691 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC19_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48717 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 48723 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48774 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48786 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC19_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 48812 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 48818 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48869 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48881 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC19_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 48907 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 48913 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 48964 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 48976 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC19_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49002 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 49008 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49059 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49071 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC19_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49097 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 49103 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49154 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49166 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC19_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49192 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 49198 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49249 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49261 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC19_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC19_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49287 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 49293 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49344 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49356 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC19_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC19_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49382 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 49388 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49439 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49451 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC20_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49477 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 49483 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 49505 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49517 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC20_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49543 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 49549 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 49571 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49583 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC20_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49607 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 49613 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 49645 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49655 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC20_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49679 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 49685 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 49717 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49727 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC20_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49753 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 49759 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49810 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49822 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC20_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 49848 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 49854 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 49905 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 49917 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC20_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 49943 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 49949 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50000 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50012 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC20_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50038 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 50044 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50095 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50107 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC20_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50133 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 50139 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50190 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50202 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC20_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50228 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 50234 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50285 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50297 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC20_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC20_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50323 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 50329 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50380 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50392 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC20_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC20_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50418 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 50424 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50475 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50487 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC21_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50513 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 50519 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 50541 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50553 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC21_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50579 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 50585 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 50607 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50619 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC21_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50643 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 50649 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 50681 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50691 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC21_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50715 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 50721 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 50753 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50763 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC21_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50789 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 50795 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50846 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50858 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC21_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 50884 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 50890 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 50941 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 50953 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC21_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 50979 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 50985 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51036 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51048 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC21_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51074 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 51080 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51131 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51143 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC21_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51169 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 51175 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51226 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51238 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC21_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51264 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 51270 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51321 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51333 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC21_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC21_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51359 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 51365 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51416 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51428 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC21_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC21_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51454 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 51460 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51511 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51523 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Fields_Rc0(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Fields_Rc0

  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #define get-values-from-icache */
#define FLM cache_entry->crack.XFL.FLM /* default in icache - extraction */
#define frB cache_entry->crack.XFL.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.XFL.FRB_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51544 "semantics.c"

#define insn cache_entry->crack.XFL.insn
  unsigned_word nia;
#line 4675 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Fields\n"));
#line 51550 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Fields, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4675 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    int i;
    for (i = 0; i < 8; i++) {
      if ((FLM & BIT8(i))) {
        FPSCR &= ~MASK32(i*4, i*4+3);
        FPSCR |= MASKED32(*frB, i*4, i*4+3);
      }
    }
    FPSCR_END(Rc);
  }
#line 51571 "semantics.c"
  return nia;
  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #undef get-values-from-icache */
#undef FLM
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 51578 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Move_To_FPSCR_Fields_Rc1(cpu *processor,
                                  idecode_cache *cache_entry,
                                  unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Move_To_FPSCR_Fields
#undef MY_PREFIX
#define MY_PREFIX Move_To_FPSCR_Fields_Rc1

  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #define get-values-from-icache */
#define FLM cache_entry->crack.XFL.FLM /* default in icache - extraction */
#define frB cache_entry->crack.XFL.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.XFL.FRB_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51599 "semantics.c"

#define insn cache_entry->crack.XFL.insn
  unsigned_word nia;
#line 4675 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Move To FPSCR Fields\n"));
#line 51605 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Move_To_FPSCR_Fields, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4675 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    int i;
    for (i = 0; i < 8; i++) {
      if ((FLM & BIT8(i))) {
        FPSCR &= ~MASK32(i*4, i*4+3);
        FPSCR |= MASKED32(*frB, i*4, i*4+3);
      }
    }
    FPSCR_END(Rc);
  }
#line 51626 "semantics.c"
  return nia;
  /* extraction: 0.63,6./,7.FLM,15./,16.FRB,21.711,31.Rc #undef get-values-from-icache */
#undef FLM
#undef frB
#undef FRB_BITMASK
#undef Rc
#line 51633 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC22_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51659 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 51665 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 51687 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51699 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC22_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51725 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 51731 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 51753 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51765 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC22_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51789 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 51795 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 51827 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51837 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC22_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 51861 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 51867 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 51899 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 51909 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC22_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 51935 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 51941 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 51992 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52004 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC22_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52030 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 52036 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52087 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52099 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC22_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52125 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 52131 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52182 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52194 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC22_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52220 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 52226 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52277 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52289 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC22_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52315 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 52321 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52372 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52384 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC22_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52410 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 52416 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52467 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52479 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC22_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC22_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52505 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 52511 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52562 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52574 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC22_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC22_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52600 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 52606 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 52657 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52669 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC23_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52695 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 52701 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 52723 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52735 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC23_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52761 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 52767 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 52789 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52801 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC23_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52825 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 52831 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 52863 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52873 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC23_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 52897 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 52903 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 52935 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 52945 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC23_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 52971 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 52977 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53028 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53040 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC23_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53066 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 53072 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53123 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53135 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC23_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53161 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 53167 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53218 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53230 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC23_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53256 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 53262 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53313 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53325 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC23_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53351 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 53357 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53408 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53420 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC23_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53446 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 53452 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53503 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53515 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC23_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC23_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53541 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 53547 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53598 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53610 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC23_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC23_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53636 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 53642 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 53693 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53705 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC24_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53731 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 53737 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 53759 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53771 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC24_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53797 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 53803 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 53825 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53837 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC24_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 53861 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 53867 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 53899 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53909 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC24_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 53933 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 53939 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 53971 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 53981 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC24_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54007 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 54013 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54064 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54076 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC24_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54102 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 54108 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54159 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54171 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC24_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54197 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 54203 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54254 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54266 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC24_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54292 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 54298 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54349 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54361 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC24_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54387 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 54393 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54444 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54456 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC24_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54482 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 54488 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54539 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54551 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC24_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC24_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54577 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 54583 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54634 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54646 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC24_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC24_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54672 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 54678 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 54729 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54741 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC25_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54767 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 54773 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 54795 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54807 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC25_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54833 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 54839 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 54861 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54873 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC25_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 54897 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 54903 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 54935 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 54945 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC25_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 54969 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 54975 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 55007 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC25_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55043 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 55049 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55100 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55112 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC25_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55138 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 55144 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55195 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55207 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC25_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55233 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 55239 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55290 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55302 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC25_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55328 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 55334 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55385 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55397 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC25_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55423 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 55429 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55480 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55492 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC25_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55518 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 55524 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55575 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55587 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC25_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC25_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55613 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 55619 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55670 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55682 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC25_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC25_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55708 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 55714 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 55765 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55777 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC26_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55803 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 55809 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 55831 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55843 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC26_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 55869 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 55875 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 55897 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55909 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC26_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 55933 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 55939 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 55971 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 55981 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC26_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56005 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 56011 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 56043 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56053 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC26_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56079 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 56085 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56136 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56148 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC26_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56174 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 56180 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56231 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56243 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC26_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56269 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 56275 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56326 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56338 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC26_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56364 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 56370 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56421 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56433 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC26_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56459 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 56465 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56516 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56528 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC26_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56554 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 56560 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56611 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56623 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC26_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC26_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56649 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 56655 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56706 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56718 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC26_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC26_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56744 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 56750 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 56801 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56813 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC27_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56839 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 56845 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 56867 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56879 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC27_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 56905 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 56911 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 56933 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 56945 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC27_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 56969 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 56975 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 57007 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC27_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57041 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 57047 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 57079 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57089 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC27_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57115 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 57121 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57172 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57184 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC27_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57210 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 57216 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57267 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57279 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC27_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57305 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 57311 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57362 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57374 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC27_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57400 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 57406 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57457 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57469 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC27_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57495 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 57501 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57552 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57564 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC27_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57590 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 57596 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57647 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57659 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC27_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC27_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57685 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 57691 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57742 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57754 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC27_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC27_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57780 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 57786 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 57837 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57849 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC28_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 57875 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 57881 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 57903 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57915 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC28_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 57941 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 57947 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 57969 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 57981 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC28_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58005 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 58011 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 58043 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58053 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC28_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58077 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 58083 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 58115 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58125 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC28_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58151 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 58157 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58208 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58220 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC28_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58246 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 58252 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58303 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58315 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC28_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58341 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 58347 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58398 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58410 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC28_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58436 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 58442 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58493 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58505 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC28_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58531 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 58537 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58588 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58600 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC28_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58626 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 58632 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58683 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58695 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC28_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC28_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58721 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 58727 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58778 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58790 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC28_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC28_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58816 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 58822 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 58873 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58885 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC29_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 58911 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 58917 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 58939 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 58951 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC29_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 58977 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 58983 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 59005 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59017 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC29_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59041 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 59047 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 59079 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59089 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC29_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59113 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 59119 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 59151 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59161 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC29_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59187 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 59193 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59244 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59256 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC29_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59282 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 59288 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59339 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59351 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC29_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59377 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 59383 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59434 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59446 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC29_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59472 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 59478 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59529 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59541 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC29_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59567 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 59573 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59624 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59636 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC29_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59662 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 59668 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59719 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59731 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC29_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC29_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59757 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 59763 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59814 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59826 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC29_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC29_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 59852 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 59858 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 59909 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59921 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC30_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 59947 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 59953 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 59975 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 59987 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC30_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60013 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 60019 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 60041 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60053 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC30_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60077 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 60083 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 60115 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60125 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC30_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60149 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 60155 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 60187 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60197 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC30_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60223 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 60229 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60280 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60292 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC30_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60318 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 60324 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60375 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60387 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC30_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60413 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 60419 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60470 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60482 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC30_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60508 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 60514 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60565 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60577 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC30_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60603 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 60609 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60660 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60672 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC30_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60698 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 60704 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60755 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60767 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC30_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC30_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60793 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 60799 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60850 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60862 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC30_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC30_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 60888 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 60894 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 60945 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 60957 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC31_Rc0(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 60983 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 60989 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 61011 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61023 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Select_FRC31_Rc1(cpu *processor,
                                   idecode_cache *cache_entry,
                                   unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Select
#undef MY_PREFIX
#define MY_PREFIX Floating_Select_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61049 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4729 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Select\n"));
#line 61055 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Select, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4729 "./ppc-instructions"
  {
    if (CURRENT_MODEL == MODEL_ppc601) {
      program_interrupt(processor, cia, optional_instruction_program_interrupt);
    } else {
      unsigned64 zero = 0;
      FPSCR_BEGIN;
      if (is_NaN(*frA, 0) || is_less_than (frA, &zero)) *frT = *frB;
      else						    *frT = *frC;
      FPSCR_END(Rc);
      PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
    }
  }
#line 61077 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.23,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61089 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC31_Rc0(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61113 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 61119 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 61151 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61161 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Multiply_FRC31_Rc1(cpu *processor,
                                     idecode_cache *cache_entry,
                                     unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Multiply
#undef MY_PREFIX
#define MY_PREFIX Floating_Multiply_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61185 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3849 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply\n"));
#line 61191 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Multiply, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3849 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = *(double*)frA * *(double*)frC;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRC_BITMASK, Rc);
  }
#line 61223 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16./,21.FRC,26.25,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61233 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC31_Rc0(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61259 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 61265 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61316 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61328 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplySubtract_FRC31_Rc1(cpu *processor,
                                             idecode_cache *cache_entry,
                                             unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplySubtract_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61354 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4057 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Subtract\n"));
#line 61360 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4057 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product - *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61411 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.28,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61423 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC31_Rc0(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61449 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 61455 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61506 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61518 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_MultiplyAdd_FRC31_Rc1(cpu *processor,
                                        idecode_cache *cache_entry,
                                        unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_MultiplyAdd_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61544 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 3967 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Multiply-Add\n"));
#line 61550 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 3967 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = product + *(double*)frB;
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61601 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.29,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61613 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC31_Rc0(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61639 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 61645 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61696 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61708 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplySubtract_FRC31_Rc1(cpu *processor,
                                                      idecode_cache *cache_entry,
                                                      unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplySubtract
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplySubtract_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61734 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4237 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Subtract\n"));
#line 61740 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplySubtract, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4237 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the subtract */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product - *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61791 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.30,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61803 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC31_Rc0(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC31_Rc0

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 0 /* default in icache - constant field */
#line 61829 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 61835 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61886 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61898 "semantics.c"

#undef insn
}

PSIM_EXTERN_SEMANTICS\
(unsigned_word)
semantic_Floating_Negative_MultiplyAdd_FRC31_Rc1(cpu *processor,
                                                 idecode_cache *cache_entry,
                                                 unsigned_word cia)
{
#undef MY_INDEX
#define MY_INDEX itable_Floating_Negative_MultiplyAdd
#undef MY_PREFIX
#define MY_PREFIX Floating_Negative_MultiplyAdd_FRC31_Rc1

  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #define get-values-from-icache */
#define frT cache_entry->crack.A.frT /* in icache - extraction */
#define FRT_BITMASK cache_entry->crack.A.FRT_BITMASK /* in icache - extraction */
#define frA cache_entry->crack.A.frA /* in icache - extraction */
#define FRA_BITMASK cache_entry->crack.A.FRA_BITMASK /* in icache - extraction */
#define frB cache_entry->crack.A.frB /* in icache - extraction */
#define FRB_BITMASK cache_entry->crack.A.FRB_BITMASK /* in icache - extraction */
#define frC cache_entry->crack.A.frC /* in icache - extraction */
#define FRC_BITMASK cache_entry->crack.A.FRC_BITMASK /* in icache - extraction */
#define Rc 1 /* default in icache - constant field */
#line 61924 "semantics.c"

#define insn cache_entry->crack.A.insn
  unsigned_word nia;
#line 4147 "./ppc-instructions"
  ITRACE(trace_semantics, ("semantics Floating Negative Multiply-Add\n"));
#line 61930 "semantics.c"

  /* monitoring: */
  if (WITH_MON & MONITOR_INSTRUCTION_ISSUE) {
    mon_issue(itable_Floating_Negative_MultiplyAdd, processor, cia);
  }

  /* semantics: */
  nia = cia + 4;
#line 4147 "./ppc-instructions"
  {
    FPSCR_BEGIN;
    double product; /*HACK! - incorrectly loosing precision ... */
    /* compute the multiply */
    if (is_invalid_operation(processor, cia,
                             *frA, *frC,
                             fpscr_vxsnan | fpscr_vximz,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    (unsigned64*)&product, *frA, 0, *frC,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      product = *(double*)frA * *(double*)frC;
    }
    /* compute the add */
    if (is_invalid_operation(processor, cia,
                             product, *frB,
                             fpscr_vxsnan | fpscr_vxisi,
                             0, /*single?*/
                             0) /*negate?*/) {
      invalid_arithemetic_operation(processor, cia,
                                    frT, product, *frB, 0,
                                    0, /*instruction_is_frsp*/
                                    0, /*instruction_is_convert_to_64bit*/
                                    0, /*instruction_is_convert_to_32bit*/
                                    0); /*single-precision*/
    }
    else {
      /*HACK!*/
      double s = -(product + *(double*)frB);
      *(double*)frT = s;
    }
    FPSCR_END(Rc);
    PPC_INSN_FLOAT(FRT_BITMASK, FRA_BITMASK | FRB_BITMASK | FRC_BITMASK, Rc);
  }
#line 61981 "semantics.c"
  return nia;
  /* extraction: 0.63,6.FRT,11.FRA,16.FRB,21.FRC,26.31,31.Rc #undef get-values-from-icache */
#undef frT
#undef FRT_BITMASK
#undef frA
#undef FRA_BITMASK
#undef frB
#undef FRB_BITMASK
#undef frC
#undef FRC_BITMASK
#undef Rc
#line 61993 "semantics.c"

#undef insn
}

#endif /* _SEMANTICS_C_*/
